/*****************************************************************************
 * 
 *  jsMath: Mathematics on the Web
 *  
 *  This jsMath package makes it possible to display mathematics in HTML pages
 *  that are viewable by a wide range of browsers on both the Mac and the IBM PC,
 *  including browsers that don't process MathML.  See
 *  
 *            http://www.math.union.edu/locate/jsMath
 *
 *  for the latest version, and for documentation on how to use jsMath.
 *
 *  Copyright 2004-2006 by Davide P. Cervone
 * 
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *  
 *****************************************************************************/

if (!window.jsMath) {jsMath = {}}
if (!jsMath.Script) {jsMath.Script = {}}

jsMath.Script.Uncompress = function (data) {
  for (var k = 0; k <  data.length; k++) {
    var d = data[k]; var n = d.length;
    for (var i = 0; i < n; i++) {if (typeof(d[i]) == 'number') {d[i] = d[d[i]]}}
    data[k] = d.join('');
  }
  eval(data.join(''));
}

//start = new Date().getTime();
jsMath.Script.Uncompress([
  ['if(!','window','.','jsMath','||!',1,'.','jsMath.','loaded','){var ','jsMath_old','=',1,'.',3,';',0,'document.','getElementById','||!',17,'childNodes||!',17,'createElement','){','alert("','The',' mathematics ','on this page requires W3C DOM support in its JavaScript. "+"Unfortunately, your ','browser',' doesn\'t seem to have this.");}','else{',1,'.',3,'={version:"3.3d",document:document,',1,':',1,',sizes:[50,60,70,85,100,120,144,173,207,249],styles:{".math','":"font-family: serif; font-style: normal; font-weight: normal','",".typeset',40,'","div.typeset','":"text-align: ','center; margin: 1em 0px;","span.typeset',44,'left',41,' span',44,'left','; border',':0px; margin:0px','; padding',':0px','",".typeset .','normal',40,56,'size0','":"font-size: ','50','%",".typeset .','size1',61,'60',63,'size2',61,'70',63,'size3',61,'85',63,'size4',61,'100',63,'size5',61,'120',63,'size6',61,'144',63,'size7',61,'173',63,'size8',61,'207',63,'size9',61,'249',63,'cmr10','":"font-family: jsMath-',100,', serif',56,'cmbx10',101,105,', ',3,'-',100,56,'cmti10',101,113,', ',3,'-',100,56,'cmmi10',101,121,56,'cmsy10',101,125,56,'cmex10',101,129,56,'textit','":"font-family: serif; font-','style:italic',56,'textbf',134,'weight:bold',56,'link":"','text-decoration',': none',56,'error',61,'10pt; font-style: italic; "+"','background-color',': #FFFFCC',54,': 1px; "+"border: ','1px solid',' #CC0000',56,'blank":"','display:inline-block','; ','overflow:hidden',52,':0px none; width:0px; height:0px;",".','typeset .','spacer','":"',156,'","#jsMath_message":"','position:fixed','; bottom:1px; ','left:2px; ',148,':#E6E6E6','; "+"border: solid 1px #959595; margin:0px; padding: ','1px 8px','; "+"z-index:102; color',': black','; font-size',':','small; ','width:auto',';","#jsMath_panel','":"',166,'; bottom:1.5em; right:1.5em',54,': .8em 1.6em; "+"',148,':#DDDDDD; border: outset ','2px; "+"z-index:103; ',178,179,' .disabled":"color:#888888","#jsMath_panel .infoLink','":"font-size:','85%","#','jsMath_button','":"',166,167,'right:2px; ',148,':white',171,'0px 3px 1px 3px',173,':black; ',142,':none',175,':x-small; "+"',178,'; ','cursor:hand',';","#','jsMath_global":"font-',135,';","#jsMath_float','":"','position:absolute','; top:0px; left:0px; max-width:80%; "+"z-index:101; ',178,'; height:auto',214,' .drag":"',148,186,'1px; height:12px',175,': 1px',214,' .close":"',148,170,52,': inset 1px; width:8px; height:8px; margin: 1px 2px',214,' .source":"',148,':#E2E2E2',52,': outset 1px; "+"',178,219,54,': 8px 15px; "+"font-family: courier, fixed',175,': 90%","#jsMath_noFont',' .message":"text-align: center; padding: .8em 1.6em; border: 3px solid #DD0000; "+"background-color: #FFF8F8; color: #AA0000; font-size:',177,178,211,'jsMath_noFont .link":"padding: 0px 5px 2px 5px',52,': 2px outset; ',148,':#E8E8E8; "+"color:black',175,':80%; ',178,'; ',210,211,'jsMath_PrintWarning',245,'x-',177,178,';","@media print":"#',193,' {display:none','}\\n"+"#jsMath_Warning',267,'}","@media screen":"#',260,267,'}"},Element',':function(','_1){return ',7,17,18,'("jsMath_"+_1);},','BBoxFor',274,'s','){this.','hidden.innerHTML','="<nobr><span class=\\"typeset\\"><span class=\\"scale\\">"+s+"</span></span></nobr>";var _3={w:this.','hidden','.offsetWidth',',h:this.',286,'.offsetHeight','};this.',284,'="";return _3;},EmBoxFor',274,'s',9,'_5=',7,'Global.cache','.R;',0,'_5[this.em]){_5[this.em]={};}',0,'_5','[this.em][s',']){var _6','=this.BBoxFor','(s);_5',305,']={w:_6.w/this.em,h:_6','.h/this.em};}return ','_5',305,'];},','EmBoxForItalics',274,'s',9,'_8=',7,299,'.R;',0,'_8[this.em]){_8[this.em]={};}',0,'_8',305,']){var _9',307,'(s);if(s.match(/<i>|class=\\"(icm|italic|igreek|iaccent)/i)){_9.w',307,'(s+',7,'Browser.','italicString',').w-',7,334,'italicCorrection',';}_8',305,']={w:_9.w/this.em,h:_9',311,'_8',305,'];},Init',':function(){','if(',7,'Setup.inited','!=1){',0,7,350,'){',7,'Setup.','Body();}if(',7,350,'!=1){if(',7,350,'==-100','){return;}',25,'It looks like ',3,' failed to set up properly (error code "+',7,350,'+").  "+"I will try to keep going, but it could get ugly.");',7,350,'=1;}}this.em',307,'("<span style=\\""+',7,334,'block+";','width:13em;height:1em','\\"></span','>").w/13;if(this.em==0',283,'em',307,'("<img src=\\""+',7,'blank+"\\" style=\\"',381,'\\"/>").w/13;}var _a=',7,299,'.B;',0,'_a[this.em]){_a[this.em]={};','_a[this.em].','bb',307,'("x");var hh=',397,'bb.h;',397,'d',307,'("x"+',7,'HTML.Rule(1,','hh/',7,'em)).h-hh;if(',7,334,335,'){',397,'ic=',7,280,'(',7,334,335,').w;}}',7,334,339,'=',397,'ic;var bb=',397,'bb;var h=bb.h;var d=',397,'d;this.h=(h-d)/this.em;this.d=d/this.em;this.hd=this.h+this.d;this.xWidth=bb.w;this.',357,'TeXfonts','();var _f=this.','EmBoxFor("<span class','=\\"',100,'\\">M</span>").w/2;this.TeX.M_height=_f*(26/14);this.TeX.h=this.h;this.TeX.d=this.d;this.TeX.hd=this.hd;this.Img.Scale();',0,'this.initialized',283,357,'Sizes','();this.','Img.UpdateFonts();}this.p_height=(this.','TeX.cmex10[','0].h+this.',449,'0].d)/0.85;',443,'=1;},ReInit',347,'var w',307,'("x").w;if(w!=this.xWidth',283,'Init();}},Loaded',347,'if(',10,9,'_11=["Process","ProcessBeforeShowing","ConvertTeX","ConvertTeX2","ConvertLaTeX","ConvertCustom","CustomSearch","Synchronize","Macro","document"];','for(var i=0;i<','_11','.length;i++){if(',10,'[_11[i]]){delete ',10,'[_11[i]];}}}if(',10,'){this.Insert(',3,',',10,');}',10,'=null;',7,8,'=1;},Add',274,'dst,src){for(var id in src){','dst[id]=src[id','];}},Insert',274,485,'if(dst[id]&&typeof (src[id])=="object"&&(','typeof (dst[id])=="','object"||',491,'function")){this.Insert(dst[id],src[id]);}',31,486,'];}}},Package',274,'obj,def',474,'obj.prototype,def);}};',7,'Global={isLocal:1,cache:{','T:{},D:{},R:{},B',':{}},ClearCache',347,7,299,'={',504,':{}};},GoGlobal',274,'_1b',9,'url=String(',7,1,'.','location);','var c=(',7,'isCHMmode','?"#":"?");if(_1b){url=url.replace(/\\?.*/,"")+"?"+_1b;}',7,'Controls.','Reload(',7,'root+"',3,'-global.html"+c+escape(url));},Init',347,'if(',7,'Controls.cookie','.global=="always"&&!',7,'noGoGlobal','){','if(navigator.','accentColorName',365,0,7,1,'){',7,1,'=',1,';}',7,525,8,'=1;',7,525,'defaults.hiddenGlobal',480,'this.GoGlobal(',7,525,'SetCookie(2));}},Register',347,'var _1e=',7,1,'.parent;',0,7,'isCHMode){',7,522,'=(',7,1,'.','location.protocol','=="mk:");}try{',0,7,522,283,'Domain();}if(_1e.',3,'&&_1e.',7,'isGlobal){_1e.',7,'Register(',7,1,');}}','catch(err','){',7,537,'=1;}},Domain',347,'if(navigator.appName=="Microsoft Internet Explorer"&&navigator.platform=="MacPPC"&&navigator.','userProfile','!=null',365,'if(',1,'==parent',365,'var _1f=',7,17,'domain;try{while(true){try{if(parent.',17,'title!=null','){return;}}',593,'){}',0,17,'domain.match(/\\..*\\./)){break;}',7,17,'domain=',7,17,'domain.replace(/^[^.]*\\./,"");}}',593,'){}',7,17,621,'_1f;}};',7,'Script={request:null,Init',347,'if(!(',7,534,'.asynch&&',7,534,'.progress',')){if(',1,'.XMLHttpRequest){try{','this.request','=new XMLHttpRequest;}',593,'){}}',0,644,'&&',1,'.','ActiveXObject',9,'xml=["MSXML2.XMLHTTP.5','.0","MSXML2.XMLHTTP','.4',656,'.3',656,'","Microsoft.XMLHTTP"];',466,'xml.length&&!',644,';i++){try{',644,'=new ',653,'(xml[i]);}',593,'){}}}}',0,644,'||',7,357,'domainChanged',283,'Load=this.delayedLoad;this.needsBody=1;}},Load',274,'url,_23){if(_23){',7,'Message.Set("Loading "+url);',7,'Script.','Delay(1);',7,'Script.Push(','this,"xmlRequest",url',');',7,688,7,'Message',',"Clear");}',31,7,688,689,');}},xmlRequest',274,'url){','this.blocking','=1;try{',644,'.open("GET",url,false);',644,'.send(null);}',593,'){throw "jsMath can\'t load the file \'"+url+"\'\\n"+"',694,': "+err.message;}if(',644,'.status','&&',644,714,'>=400',710,'Error status: "+',644,714,';}',0,'url.match(/\\.js$/)){','return (',644,'.responseText',');}var _25=','this.queue',';',730,'=[];',7,1,'.eval(',644,728,');',703,'=0;','this.queue=this.queue.concat(','_25);this.Process();return "";},cancelTimeout:30*1000,iframe:null,blocking:0,cancelTimer:null,needsBody:0,queue:[],Synchronize',274,'_26,_27){','if(typeof (','_26)!="string"){',7,688,'null,_26,_27);}',31,7,688,7,1,',"eval",_26);}},Push',274,'_28,_29,_2a){',730,'[',730,'.length]=[_28,_29,_2a];if(!(',703,'||(this.needsBody&&!',7,17,'body))){this.Process();}},Process',347,'while(',730,'.length&&!',703,9,'_2b=',730,'[0];var _2c=',730,'.slice(1);',730,'=[];var _2d=_2b[0];var _2e=_2b[1];var _2f=_2b[2];if(_2d){_2d[_2e](_2f);}',31,'if(_2e){_2e(_2f);}}',742,'_2c);}},delayedLoad',274,'url',283,'Push(this,"startLoad",url);},startLoad',274,'url){','this.iframe','=',7,17,23,'("iframe");','this.iframe.style.','visibility="',286,'";',797,'position="absolute";',797,'width="0px";',797,'height="0px";if(',7,17,'body.firstChild','){',7,17,'body.insertBefore(',791,',',7,17,809,');}',31,7,17,'body','.appendChild(',791,');}',703,'=1;this.','url=url;',0,725,791,'.src=url;}',31,791,'.src=',7,528,3,'-loader.html";}if(url.substr(0,',7,'root.length',')==',7,'root){url=url.substr(',7,842,');}',7,683,'this.cancelTimer','=setTimeout("',7,685,'cancelLoad','()",this.cancelTimeout);},endLoad',274,'_32){if(',851,'){clearTimeout(',851,');',851,'=null;}',7,694,'.Clear();if(_32!="cancel"){',703,'=0;this.Process','();}},Start',347,'this.tmpQueue','=',730,';',730,'=[];},End',347,742,872,');delete ',872,';},',855,347,851,480,7,694,'.Set("Can\'t load file");this.endLoad("cancel");},Delay',274,'_33){',703,'=1;setTimeout("',7,685,'endDelay','()",_33);},',897,347,703,869,'();},','imageCount',':0,WaitForImage',274,'_34){',703,828,904,'++;if(this.img==null',283,'img=[];}var img=new Image',447,'img[this.img.length]=img;img.onload=function(){if(--',7,685,904,'==0){',7,685,897,'();}};img.onerror','=img.onload;img.','onabort',924,'src=_34;},Uncompress',274,'_36){','for(var k=0;k<','_36.length;k++){var d=_36[k];var n=d.length;',466,'n;i++){',746,'d[i])=="number"){d[i]=d[d[i]];}}_36[k]=d.join("");}',1,736,'_36.join(""));}};',7,694,'={blank:null,message:null,text:null,clear:null,Init',347,0,7,17,'body||!',7,534,640,365,'if(',7,357,'stylesReady){','this.message','=',7,'Setup.DIV("message",{visibility:"hidden','"});}',31,955,'=',7,958,'",position:"absolute",','bottom:"1px",left:"2px",','backgroundColor',':"#E6E6E6",border:"solid 1px #959595",margin:"0px",padding:"1px 8px",zIndex:102,color:"black",fontSize:"small",width:"auto"});}','this.text','=',7,17,'createTextNode','("");',955,824,969,');',955,'.onmousedown=',7,'Translate.Cancel;},Set',274,'_3b,_3c){','if(this.clear){clearTimeout(this.clear',');','this.clear',864,'if(',7,534,640,'){',0,969,283,'Init();',0,969,613,'if(',7,334,'textNodeBug','){',955,'.innerHTML','=_3b;}',31,969,'.nodeValue',1008,'this.message.style.',798,'visible";if(_3c){',1013,'cursor="pointer";',0,1013,'cursor){',1013,'cursor="hand";}',955,'.title=" Cancel Processing of Math ";}',31,1013,'cursor="";',955,'.title="";}}',31,'if(_3b.substr(0,8)!="Loading "){',7,1,714,'=_3b;}}},Clear',347,985,');}',987,'=setTimeout("',7,694,'.doClear()",1000);},doClear',347,'if(',987,'){',987,480,7,1,714,'="";if(',969,'){',969,1011,'="";}if(',955,'){',1013,798,286,'";}}},Blank',347,'if(','this.blank','||!',7,17,'body',365,1067,'=',7,357,'DIV("blank",{position:(',7,334,'msiePositionFixedBug','?"absolute":"fixed"),top:"0px",left:"0px",bottom:"0px",right:"0px",zIndex:101,',967,':"white"});if(',7,334,'msieBlankBug','){',1067,1007,'="&nbsp;";',1067,'.style.width="110%";',1067,'.style.height="110%";}},UnBlank',347,'if(',1067,'){',7,17,'body.removeChild(',1067,');}',1067,'=null;}};',7,'Setup={',8,':[],DIV',274,'id,_3e',9,'div=',7,17,23,'("div");div.id="jsMath_"+id;','for(var i in ','_3e){div.style[i]=_3e[i];}',0,7,17,'body.hasChildNodes){',7,17,'body',824,'div);}',31,7,17,813,'div,',7,17,809,');}return div;},Script',274,'_41,_42){if(','this.loaded[_41',']){return;}',31,1140,']=1;}',0,'_41.match("^([a-zA-Z]+:/?)?/")){_41=',7,'root+_41;}',7,685,'Load(_41,_42);},Hidden',347,7,286,'=this.DIV("Hidden",{visibility:"',286,965,'top:0,left:0,border:0,padding:0,margin:0});',7,'hiddenTop=',7,286,';return;},Source',347,'if(',7,'Autoload&&',7,'Autoload.root','){',7,'root=',7,1169,';}',31,7,'root="";var _43=',7,17,'getElementsByTagName("','script");if(_43){',466,'_43','.length;i++){var ','src=_43[i].src;if(src&&src.match("(^|/)',7,'js$")){',7,1172,'src.','replace(/',7,'js$/,"");i=_43.length;}}}}if(',7,'root.charAt(0)=="/"){',7,1172,7,17,577,'+"//"+',7,17,'location.host+',7,'root;}',31,0,7,'root.match','(/^[a-z]+:/i)){src','=new String(',7,17,519,7,1172,'src','.replace(new RegExp','("[^/]*$"),"")+',7,'root;while(',7,1211,'("/[^/]*/\\\\.\\\\./")){',7,1172,7,'root',1220,'("/[^/]*/\\\\.\\\\./"),"/");}}}',7,'Img.',1172,7,528,'fonts/";',7,'blank=',7,528,'blank.gif";this.Domain();},Domain',347,'try{',7,17,'domain;}',593,365,'var _46="";var _47=',7,17,'domain;if(',7,1211,'("://([^/]*)/")){_46=RegExp.$1;}_46=_46.replace(/:\\d+$/,"");if(_46==""||_46==_47',365,599,'onLine&&','navigator.',600,'&&',7,17,'all',365,'_46=_46.split(/\\./);_47=_47.split(/\\./);if(_46.length<2||_47.length<2||','_46[_46.length-','1',']!=_47[_47.length-','1]||',1269,'2',1271,'2]){this.','DomainWarning','();return;}var _48=',1269,'2]+"."+',1269,'1];for(var i=3;i<=_46.length&&i<=_47',468,1269,'i',1271,'i]){break;}_48=',1269,'i]+"."+_48;}',7,17,621,'_48;this.',677,'=1;},',1277,347,25,'In order for ',3,' to be able to load the additional "+"components that it may need, the ',7,'js file must be "+"',8,' from a server in the same domain as the page that "+"contains it.  Because that is not the case for this page, "+"the',27,'displayed here may not appear correctly.");},','EncodeFont',274,'_4a',9,'_4b=',7,'TeX[_4a];if(_4b[0].c!=null',365,930,'128;k++){var _4d=_4b[k];_4b[k]=_4d[3];if(_4b[k]==null){_4b[k]={};}_4b[k].w=_4d[0];_4b[k].h=_4d[1];if(_4d[2]!=null){_4b[k].d=_4d[2];}_4b[k].c=',7,'TeX.encoding[k];}},Fonts',347,466,7,'TeX.fam',1185,'_4f=',7,1323,'[i];if(_4f',283,1308,'(_4f);}}},TeXfont',274,'_50',9,'_51=',7,'TeX[_50];if(_51==null',365,'var WH=',7,438,'=\\""+_50+"\\">"+_51[65','].c+"</span>");','_51.hd=WH.h;_51.dh=0.05;_51.d=',7,438,'=\\""+_50+"\\">"+_51[65].c+',7,408,'_51.hd)+"</span>").h-_51.hd;_51.h=_51.hd-_51.d;','if(_50=="',121,'"){_51.skewchar=','127;}',31,1351,125,1353,'48;}}},',436,347,466,7,1323,468,7,1323,'[i]){this.TeXfont(',7,1323,'[i]);}}},Sizes',347,7,'TeXparams','=[];for(var j=0;j<',7,'sizes.length;j++){',7,1374,'[j]={};}',1118,7,'TeX){',746,7,'TeX[i])!="object"){for(var j=0;j<',7,'sizes.length;j++){',7,1374,'[j][i]=',7,'sizes[j]*',7,'TeX[i]/100;}}}},Styles',274,'_57){',0,'_57){_57=',7,'styles;_57[".',161,'scale"]="font-size:"+',7,534,'.scale+"%";this.stylesReady=1;}',7,688,'this,"','AddStyleSheet','",_57);if(',7,334,'styleChangeDelay','){',7,688,7,'Script,"Delay",1);}},',1410,274,'_58',9,'_59=',7,17,1181,'head")[0];var _5a="";for(var id in _58){_5a+=id+" {"+_58[id]+"}\\n";}if(',7,17,'createStyleSheet){_59.insertAdjacentHTML("beforeEnd","<span',' style=\\"','display:none\\">x</span>"+"<style type=\\"text/css\\">"+_5a+"</style>");}',31,'var _5c=',7,17,23,'("style");_5c.type="text/css";_5c',824,7,17,973,'(_5a));_59',824,'_5c);}},Body',347,'if(this.inited',365,'this.inited=-','1;',7,357,'Hidden();',1450,'2;',7,334,997,1450,'3;if(',7,534,'.blank){',7,694,'.Blank();}',1450,'4;',7,357,'Styles();',1450,'5;',7,525,997,1450,'6;',7,688,7,'Setup,"User","pre-font");',1450,'7;',7,688,7,'Font,"Check");if(',7,'Font.register.length){',7,688,7,'Font,"LoadRegistered");}this.inited=1;},User',274,'_5d){}};',7,'Update={',436,274,'_5e){for(var ','_5f in ',1502,'_60 in _5e[_5f]){for(var id in _5e[_5f][_60]){',7,'TeX[_5f][_60][id]=_5e[_5f][_60][id];}}}},TeXfontCodes',274,'_62){for(var _63 in _62){',466,'_62[_63].length;i++){',7,'TeX[_63][i].c=_62[_63][i];}}}};',7,'Browser={allowAbsolute:1,allowAbsoluteDelim:0,separateSkips:0,valignBug:0,operaHiddenFix:"",','msieCenterBugFix',':"",','msieInlineBlockFix',':"",','msieSpaceFix',':"",imgScale:1,renameOK:1,',1414,':0,delay:1,version:0,','TestSpanHeight',347,7,284,'="<span','><','span style=\\""+this.block+";','height:2em;width:','1px',382,'></span>";var ','_65=',7,'hidden.firstChild;','var img=_65.firstChild;','this.spanHeightVaries','=(_65',290,'>=img',290,'&&_65',290,'>0);','this.spanHeightTooBig','=(_65',290,'>img',290,');',7,284,'="";},','TestInlineBlock',347,'this.block','="display:-moz-inline-box";','this.hasInlineBlock','=',7,'BBoxFor("<span style=\\""+this.block+";','width:10px;height:5px\\"></span>").w>0;if','(',1560,'){',7,'styles[".typeset .','blank"]=',7,1569,'blank','"].replace(/',156,'/,',1558,');',7,1569,162,'"]=',7,1569,162,1574,156,'/,"");}',31,1558,'="',156,'";',1560,'=',7,1563,1564,'(!',1560,613,1558,'+=";',158,'";var h=',7,280,'("x").h;this.mozInlineBlockBug=',7,1563,'height:"+h+"px;width:1px',382,'>x"+"<',1530,1611,';vertical-align:-"+h+"px',382,'>").h>2*h;this.widthAddsBorder=',7,1563,158,';height:1px;width:10px',';border-left:','10px solid',382,'>").w>10;','this.msieBorderBug','=',7,1563,1611,382,'>x").h!=',7,1563,1611,1623,152,382,'>x").h;this.blankWidthBug=',1627,'||',7,1563,1531,'0px',382,'>").h==0;},','TestRenameOK',347,7,284,1528,1534,'_68=',7,1537,'_68.setAttribute("name","','jsMath_test','");this.renameOK=(',7,17,'getElementsByName("',1659,'").length>0);',7,284,1555,'TestStyleChange',347,7,284,1528,' ID=\\"',1659,'\\">x</span>";var _69=',7,1537,'var w=_69',287,';',7,357,1410,'({"#',1659,191,'200%"});this.',1414,'=(_69',287,'==w);',7,284,1555,'VersionAtLeast',274,'v',9,'bv',1213,'this.version',').split(".");','v',1213,'v',1703,'if(v[1]==null){v[1]="0";}return bv[0]>v[0]||(bv[0]==v[0]&&bv[1]>=v[1]);},Init',347,7,29,'="unknown";this.',1556,447,1524,447,1649,447,1669,447,'MSIE',447,'Mozilla',447,'Opera',447,'OmniWeb',447,'Safari',447,'Konqueror','();if(','this.allowAbsoluteDelim','){',7,'Box.DelimExtend=',7,'Box.DelimExtendAbsolute;',7,'Box.Layout=',7,'Box.LayoutAbsolute;}',31,7,'Box.DelimExtend=',7,'Box.DelimExtendRelative;',7,'Box.Layout=',7,'Box.LayoutRelative;}if(','this.separateSkips','){',7,'HTML.Place=',7,'HTML.','PlaceSeparateSkips',';',7,'Typeset.prototype.','Place=',7,1761,1758,';}},MSIE',347,'if(',1539,'&&!',1547,'){',7,29,'="MSIE";',539,'platform=="','Win32"){',1733,'=1;',1752,'=1',';this.buttonCheck=1;this.',1086,'=1;this.msieDivWidthBug=1;this.',1080,828,'msieIntegralBug',828,'waitForImages',828,'msieAlphaBug=1;','this.alphaPrintBug=1',';this.',1516,'="position:relative; ";this.',1518,'=" ',156,';";this.',1520,1528,1432,156,382,'>";',7,'Macro("joinrel","\\\\mathrel{\\\\kern-5mu}"),',7,1569,'arial"]="font-family: \'Arial unicode MS\'";',7,'styles["#jsMath_message','"]=',7,1813,1574,166,'/,"',216,'").',1192,178,'/,"");',7,'styles["#jsMath_panel','"]=',7,1826,1574,166,'/,"',216,'").',1192,178,1824,7,'styles["#jsMath_button','"]="width:','1px; "+',7,1839,1574,166,'/,"',216,'").',1192,178,1824,7,1,'.onscroll=',7,525,'MoveButton;',7,1569,162,'"]=',7,1569,162,1574,156,1824,'if(','screen.deviceXDPI','&&','screen.logicalXDPI','&&',1869,'!=',1871,283,'imgScale*=',1871,'/',1869,';',7,534,'.alpha=0;}this.',335,'="<i>x</i>";',7,'EmBoxFor=',7,315,';}',31,539,1777,'MacPPC"){this.msieAbsoluteBug',828,'msieButtonBug',1785,1086,'=1;',7,'Setup.Script("jsMath-','msie-mac.js");',7,'Parser.prototype.macros.angle=["Replace","ord","<font face=\\"Symbol\\">&#x8B;</font>","normal"];',7,1826,1840,'42em; "+',7,1826,1574,178,1824,7,534,'.printwarn=0;}}',7,'Macro("not","\\\\mathrel{\\\\rlap{\\\\kern3mu','/}}");}},Mozilla',347,'if(',7,286,'.ATTRIBUTE_NODE){',7,29,'="Mozilla";',539,1777,'Win32"){',1793,';}',1733,'=1;',7,1839,'"]=',7,1839,1574,210,'/,"cursor:pointer");',7,'styles["#jsMath_noFont .link','"]=',7,1945,1574,210,'/,"cursor:pointer");',7,1919,'/}}");',539,'vendor=="Firefox"){',1702,'=',1261,'vendorSub;}',31,539,'userAgent.match','(" Firefox/([0-9.]+)( |$)")){',1702,'=RegExp.$1;}}}},',1727,347,539,'accentColorName){',7,29,'="',1727,'";','this.allowAbsolute','=',1560,';',1733,'=',1976,';this.valignBug=!',1976,1783,1004,'=1;',7,'noChangeGlobal=1;',0,1560,'){',7,1902,'old-browsers.js','");}}},Opera',347,'if(',1547,'){',7,29,'="Opera";var _6d=',1261,1963,'("Opera 7");',1976,'=0;this.delay=10;this.operaHiddenFix="[Processing]";if(_6d){',7,1902,1995,'");}}},Safari',347,539,'appVersion.match(/Safari\\//)){',7,29,'="Safari";var _6e=',1261,1963,'("Safari/([0-9]+)");_6e=(_6e)?_6e[1]:400;',466,7,1323,468,7,1323,'[i]&&',7,'TeX[',7,1323,'[i]]){',7,'TeX[',7,1323,'[i]].dh=0.1;}}',7,'TeX.axis_height+=0.05;',7,'TeX.default_rule_thickness+=0.025;',1733,'=_6e>=125;this.safariIFRAMEbug=_6e>=312&&_6e<412;this.safariButtonBug=_6e<412;this.safariImgBug',828,1004,'=1',1783,1414,'=1;}},',1731,347,539,'product&&',1261,'product.match("',1731,'")){',7,29,'="',1731,'";',1976,'=0;',1733,'=0;',539,1963,'(/',1731,'\\/(\\d+)\\.(\\d+)/)){if(RegExp.$1<3||(RegExp.$1==3&&RegExp.$2<3)){',1752,828,'valignBug=1;',7,1902,1995,'");}}',7,'Add(',7,'styles,{".',161,100,101,'cmr10, jsMath cmr10',103,56,105,101,105,', ',3,' ',105,', ',3,'-',2087,56,113,101,113,', ',3,' ',113,', ',3,'-',2087,56,121,101,121,', ',3,' ',121,56,125,101,125,', ',3,' ',125,56,129,101,129,', ',3,' ',129,'"});',7,'Font.testFont','="',3,'-',129,', ',3,' ',129,'";}}};',7,'Font={testFont:"',3,'-',129,'",fallback:"symbol",register:[],message:"<b>No ',3,' TeX fonts found</b> -- using',' image fonts instead','.<br/>\\n"+"These',' may be slow and might not print well.<br/>\\n"+"Use the jsMath control panel to get additional information.",','extra_message:"Extra TeX fonts not found: <b><span id=\\"jsMath_ExtraFonts',382,'></b><br/>"+"Using',2157,'.  This',2159,'print_message:"To print higher-resolution math symbols, click the<br/>\\n"+"<b>Hi-res Fonts for Printing</b> button on',' the jsMath control panel.<br/>\\n",','alpha_message:"If the math symbols print as black boxes, turn off <b>image alpha channels</b><br/>\\n"+"using the <B>Options</B> pane of',2167,'Test1',274,'_70,n,_72,_73','){if(n==null){n=124;}if(','_72==null){_72=2;}if(_73==null){_73="";}var wh1=',7,'BBoxFor("<span style=\\"font-family',': "+_73+_70+", serif\\">"+',7,'TeX[_70][n',1343,'var wh2=',7,2176,': serif\\">"+',7,'TeX[_70][n',1343,726,'wh1.w>_72*wh2','.w&&wh1.h!=0);},','Test2',274,'_76,n,_78,_79',2173,'_78==null){_78=2;}if(_79==null){_79="";}var wh1=',7,2176,': "+_79+_76+", serif\\">"+',7,'TeX[_76][n',1343,'var wh2=',7,2176,': serif\\">"+',7,'TeX[_76][n',1343,726,'wh2.w>_78*wh1',2190,'CheckTeX',347,'var wh=',7,2176,': "+',7,2139,'+", serif\\">"+',7,449,'1',1343,7,'nofonts=((wh.w*3>wh.h||wh.h==0)&&!this.Test1("cmr10','",null,null,"',3,'-"));if(',7,'nofonts&&(',1261,'platform!="MacPPC"||',7,29,'!="Mozilla"||!',7,334,1696,'(1.5))){wh=',7,2176,': ',129,103,'\\">"+',7,449,'1',1343,7,2226,'"));',0,7,'nofonts){',7,1902,'BaKoMa-fonts.js");}}},Check',347,'var _7d=',7,534,';this.CheckTeX();if(',7,2256,'if(_7d.autofont||_7d.f'],
  ['ont=="','tex"){','_7d.font','=','this.','fallback',';if(','_7d.warn){','jsMath.','nofontMessage=1;_7d.warn=0;',8,'Controls.','SetCookie','(0',');if(',8,'window.NoFontMessage','){',8,16,'();}else{','this.Message(this.','message',');}}}}else{if(_7d.autofont){',2,'="tex";}','if(_7d.font=="',1,'return',';}}if(',8,'noImgFonts){',2,'="unicode";}',26,'unicode"){','var _7e=({Win32:"pc",MacPPC:"mac"})[navigator.platform]||"unix";',8,'Setup.Script("jsMath-fallback','-"+_7e+".js");',8,'Box.TeXnonfallback=',8,'Box.TeX',';',8,43,'=',8,'Box.TeXfallback;return;}','if(!_7d.print&&_7d.printwarn){',4,'PrintMessage','((',8,'Browser.','alphaPrintBug&&',8,11,'cookie.alpha)?','this.print_message','+',4,'alpha_message:',60,');}if(',8,55,'waitForImages){',8,'Script.','Push(',8,'Script,"WaitForImage",',8,'blank);}',26,'symbol"){',8,38,'-symbols.js");',8,'Box.TeXnonfallback=',8,43,';',8,43,'=',8,49,8,'Img.SetFont','({cmr10',':["all"],','cmmi10',94,'cmsy10',94,'cmex10',94,'cmbx10',94,'cmti10:["all"]});',8,'Img.LoadFont','("cm-fonts");},Message',':function(','_7f','){if(',8,'Element("','Warning','")){','return;}var ','div=',8,'Setup.DIV("',112,'",{});div.innerHTML="<center><table><tr><td>"+"<div ','id=\\"jsMath_noFont\\"><div ','class=\\"message\\">"+','_7f+"<div style=\\"text-align:left\\"><span style=\\"float:left; margin: 8px 0px 0px 20px\\">"+"<span onclick=\\"',8,11,'Panel','()\\" title=\\" ','Open the ','jsMath Control Panel',' \\" class=\\"link\\">',128,'</span>"+"</span','><span style=\\"margin: 8px 20px 0px 0px; float:right\\">"+"<span onclick=\\"',8,'Font.','HideMessage',126,'Remove this font warning ',22,129,'Hide this Message',131,'></div><div style=\\"height:6px\\"></div><br clear=\\"all\\"/></div></','div>"+"<div style=\\"width:22em; height:1px\\"></div>"+"</td></tr></table></center><hr/>";},',135,':function(){','var _81=',8,111,112,'");if(_81){_81','.style.display="none";}},',52,107,'_82',109,8,111,'PrintWarning',113,114,'div=',8,117,158,119,121,'_82+"</',143,'Register',107,'_84,_85',109,'typeof (_84)=="string"){_84={name:_84};}if(!',8,'Setup.inited','&&!_85){','this.register','[',177,'.length',']=_84;',114,'_86=_84.name;var _87=_86.replace(/10$/,"");var _88=',8,'TeX.fam',180,6,'_84.prefix','==null){',188,'="";}if(!_84.style){_84.style="font-family: "+',188,'+_86+", serif";}if(!','_84.styles','){',194,'={};}','if(!','_84.macros','){',199,197,8,185,'[_88]=_86;',8,'TeX.famName[_86]=_88;',199,'[_87]=["HandleFont",_88];',8,'Add(',8,'Parser.prototype.macros,',199,');',194,'[".typeset ."+_86]=_84.style;',8,'Setup.Styles(',194,14,8,'initialized){',8,70,'Push(',8,'Setup,"TeXfont",_86);}var _89=!',8,'nofonts&&_84.test(_86,_84.testChar,_84.testFactor,',188,14,'_89&&',8,11,'cookie.font=="',1,'if(_84.','tex){_84.tex(_86,_88,_84);}',28,';}if(!_89&&',8,11,'cookie.warn&&',8,11,236,'tex"&&!',8,'nofonts){if(!',8,111,112,113,21,'extra_message);}var _8a=',8,111,'ExtraFonts");if(_8a',109,'_8a.innerHTML','!=""){',261,'+=",";}',261,'+=" "+',188,'+_86;}}if(',8,11,236,35,238,5,'){_84.',5,'(_86,_88,_84);}',114,'_8b={};_8b[_86]=["all"];',8,92,'(_8b);',8,105,'(_86',14,8,'initialized){',8,70,'Push(',8,'Img,"Scale");',8,70,'Push(',8,'Img,"UpdateFonts");}},LoadRegistered',145,'var i=0;while(i<',177,180,'){',4,169,'(',177,'[i++],1);}',177,'=[];},Load',107,'_8d){',8,'Setup.Script(',4,'URL(_8d));},URL',107,'_8e){',28,' ',8,'Img.root+_8e+"/def.js";}};',8,'Controls={cookie:{scale:100,font:"tex",autofont:1,scaleImg:0,alpha:1,warn:1,printwarn:1,stayhires:0,button:1,progress:1,asynch:0,blank:0,print:0,keep:"0D",global:"auto",hiddenGlobal:1},','cookiePath',':"/",','noCookiePattern',':/^(file|mk):$/,Init',145,4,'panel=',8,117,'panel",{display:"none"});if(!',8,55,'msieButtonBug){',4,'Button',20,'setTimeout("',8,11,339,'()",500);}},',125,145,8,'Translate.Cancel();if(',4,'loaded){',4,'Main',20,8,70,'delayedLoad(',8,'root+"jsMath-controls.html");}},',339,145,'var _8f=',8,117,'button",{});_8f.title=" Open ',128,' ";_8f.innerHTML="<span onclick=\\"',8,11,125,'()\\">jsMath</span>";if(!',8,'Global.','isLocal&&!',8,'noShowGlobal){_8f.innerHTML+="<span id=\\"jsMath_global\\" title=\\" Open jsMath Global ',125,' \\" "+"onclick=\\"',8,373,'Show(1)\\">Global&nbsp;</span>";}if(_8f.offsetWidth<30){_8f.style.width="auto";}if(!','this.cookie','.button){_8f',151,'MoveButton',145,'if(!',4,'button){',4,'button=',8,111,'button");}','this.button.style.visibility="','hidden";',395,'visible";},GetCookie',145,'if(','this.defaults',189,401,197,8,211,401,',',382,');',4,'userSet={};var _90=',8,'document.cookie',6,8,'window.location','.protocol.match(',4,327,')){_90=',4,'localGetCookie','();','this.isLocalCookie','=1;}if(_90.match(/jsMath=([^;]+)/)){var _91=RegExp.$1.split(/,/);for(var i=0;i<_91',180,';i++){var x=_91[i].match(/(.*):(.*)/);if(x[2].match(/^\\d+$/)){x[2]=1*x[2];}',382,'[x[1]]=x[2];',4,'userSet[x[1]]=1;}}},',423,145,28,' unescape(',8,417,'.search.substr(1));},',12,107,'_94){var _95=[];','for(var id in ',382,109,401,'[id]==null||',382,'[id]!=',401,'[id]){_95[_95',180,']=id+":"+',382,'[id];}}_95=_95.join(",");if(',425,109,'_94==2){',28,' "','jsMath="+escape(','_95);}',4,'localSetCookie','(_95,_94);}else{if(_95==""){_94=0;}if(',4,325,'){_95+="; ','path="+',4,325,';}if(',4,'cookieDomain',468,'domain="+',4,474,';}if(',382,'.keep!="0D"){var ms={D',':1000*60*60*24',',W',482,'*7,M',482,'*30,Y',482,'*365};var exp=new Date;exp.setTime(exp.getTime()+',382,'.keep.substr(','0,1)*ms[',382,491,'1,1)]);_95+="; expires="+exp.toGMTString();}if(_95',262,8,414,'="jsMath="+_95;var _99=',8,414,6,'_94&&!_99.match(/jsMath=/)){alert("Cookies must be enabled in order to save jsMath options");}}}',28,' null;},',464,107,'_9a,_9b){if(!_9b){',114,'_9c=String(',8,417,').replace(/\\?.*/,"");if(_9a',262,'_9c+="?',461,'_9a);}if(_9c!=',8,417,'.href){',4,'Reload(_9c);}},Reload',107,'url){if(!',4,351,28,';}',4,'loaded=0;',8,175,'=-100;',8,373,'ClearCache();if(url){',8,417,'.replace(url);}else{',8,417,'.reload();}}};',8,'Click={CheckClick',107,'_9e){if(!_9e){_9e=',8,'window.event;}if','(_9e.altKey){',8,11,125,'();}},CheckDblClick',107,'_9f){if(!_9f){_9f=',8,548,'(!',8,'Click.DblClick){',8,'Extension.Require("double-click",1);var _a0=_9f;_9f={};',443,'_a0){_9f[id]=_a0[id];}}',8,70,'Push(',8,'Click,"DblClick",[_9f,',4,'alt]);}};',8,'TeX={thinmuskip:3/18,medmuskip:4/18,thickmuskip:5/18,x_height:0.430554,quad:1,num1:0.676508,num2:0.393732,num3:0.44373,denom1:0.685951,denom2:0.344841,sup1:0.412892,sup2:0.362892,sup3:0.288888,sub1:0.15,sub2:0.247217,sup_drop:0.386108,sub_drop:0.05,delim1:2.39,delim2:1,axis_height:0.25,default_rule_thickness:0.06,big_op_spacing1:0.111111,big_op_spacing2:0.166666,big_op_spacing3:0.2,big_op_spacing4:0.6,big_op_spacing5:0.1,integer:6553.6,scriptspace:0.05,nulldelimiterspace:0.12,delimiterfactor:901,delimitershortfall:0.5,scale:1,atom:["ord","op","bin","rel","open","close","punct","ord"],fam:["cmr10","cmmi10","cmsy10","cmex10","cmti10","","cmbx10",""],famName:{cmr10:0,cmmi10:1,cmsy10:2,cmex10:3,cmti10:4,cmbx10:6},encoding:["&#xC0;","&#xC1;","&#xC2;","&#xC3;","&#xC4;","&#xC5;","&#xC6;","&#xC7;","&#xC8;","&#xC9;","&#xCA;","&#xCB;","&#xCC;","&#xCD;","&#xCE;","&#xCF;","&#xB0;","&#xD1;","&#xD2;","&#xD3;","&#xD4;","&#xD5;","&#xD6;","&#xB7;","&#xD8;","&#xD9;","&#xDA;","&#xDB;","&#xDC;","&#xB5;","&#xB6;","&#xDF;","&#xEF;","!","&#x22;","#","$","%","&#x26;","&#x27;","(",")","*","+",",","-",".","/","0","1","2","3","4","5","6","7","8","9",":",";","&#x3C;","=","&#x3E;","?","@","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","[","&#x5C;","]","^","_","`","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","{","|","}","&#x7E;","&#xFF;"],cmr10:[[0.625',',0.683],[0.','833',574,'778',574,'694',574,'667',574,'75',574,'722',574,'778',574,'722',574,'778',574,'722',574,'583',',0.694,0,{ic:0.','0778,krn:{"39":0.0778,"63":0.0778,"33":0.0778,"41":0.0778,"93":0.0778},lig:{"105":','14,"108":15}}],[0.','556',',0.694],[0.','556',600,'833',600,'833',600,'278',',0.431],[0.','306,0.431',',0.194],[0.','5',600,'5',600,'5,0.628],[0.5',600,'5,0.568],[0.75',600,'444,0,0.17],[0.5',600,'722',608,'778',608,'5,0.528,0.0972],[0.903,0.683],[1.01',574,'778,0.732,0.0486],[','0.278',',0.431,0,{','krn:{"108":-0.','278,"76":-0.319}}],[',628,',0.694,0,{lig:{"96":','60}}],[0.5',600,'833',',0.694,0.194],[','0.5',',0.75,0.0556],[0.','833',639,'778',600,'278',',0.694,0,{krn:{"','63":0.111,"33":0.111','},lig:{"39":34}}],[0.','389',',0.75,0.25],[0.','389',649,'5,0.75],[','0.778,0.583,0.0833],[','0.278,0.106',610,'333',629,'lig:{"45":','123}}],[',654,'],[0.5',649,'5,0.644','],[0.5,0.644],[0.5,0.','644',664,'644',664,'644',664,'644],[0.5,0.644],[',628,608,'278,0.431',610,'278,0.5',610,'778',',0.367,-0.133],[','0.472,0.5',610,'472',633,'62}}],[0.778',600,'75',',0.683,0,{krn:{"','116','":-0.0278,"','67',689,'79',689,'71',689,'85',689,'81',689,'84":-0.0833,"89":-0.0833,"86":-0.111,"87":-0.111}}],[0.','708',574,'722',574,'764',687,'88',689,'87',689,'65',689,'86',689,'89":-','0.0278}}],[0.','681',574,'653',',0.683,0,{','krn:{"111":-0.0833,"101":-0.0833,"117":-0.0833,"114":-0.0833,"97":-0.0833,"65":-0.111,"79":-0.0278,"67":-0.0278,"71":-0.0278,"81":-0.0278}}],[','0.785',574,'75',574,'361',687,'73":',716,'514',574,'778',687,'79',689,'67',689,'71',689,'81":-',716,'625',687,700,'917',574,'75',574,'778',687,'88',689,'87',689,'65',689,'86',689,'89":-',716,'681',687,'65','":-0.0833,"','111',689,'101',689,'97',689,'46',764,'44":-0.','0833}}],[0.','778,0.683',610,'736',687,'116',689,'67',689,'79',689,'71',689,'85',689,'81',689,700,'556',574,'722',687,'121',689,'101',764,'111',764,'114',764,'97',764,'65',764,'117":-0.',774,'75',574,'75',',0.683,0,{ic:0.','0139,',721,'1.03',813,'0139,',721,'0.75',687,'79',689,'67',689,'71',689,'81":-',716,'75',813,'025,krn:{"101',764,'111',764,'114',764,'97',764,'65',764,808,774,'611',574,'278',649,'5',600,'278',649,'5',600,'278,0.668],[0.','278',633,'92}}],[0.5',629,'krn:{"118',689,'106":0.0556,"121',689,'119":-',716,'556,0.','694,0',',{krn:{"101":0.0278,"111":0.0278,"120":-0.0278,"100":0.0278,"99":0.0278,"113":0.0278,"118":-0.0278,"106":0.0556,"121":-0.0278,"119":-0.0278}}],[0.','444',629,'krn:{"104',689,'107":-',716,'556',600,'444',608,'306',596,597,'12,"102":11,"108":13}}],[0.5',',0.431,0.194,{','ic:0.','0139,krn:{"','106":',716,'556',645,'116',689,'117',689,'98',689,'121',689,'118',689,'119":-',716,854,'306,0.668',610,'528',645,'97','":-0.0556,"','101',689,'97',689,'111',689,'99":-',716,'278',600,'833',629,'krn:{"116',689,'117',689,'98',689,'121',689,'118',689,'119":-',716,'556',629,'krn:{"116',689,'117',689,'98',689,'121',689,'118',689,'119":-',716,'5,0.431',',0',867,865,'431,0.194',867,'528,0.431',610,'392',608,'394',608,'389,0.615,0,{krn:{"121',689,'119":-',716,'556',629,'krn:{"119":-',716,'528',',0.431,0,{ic:0.',884,'97',907,'101',689,'97',689,'111',689,'99":-',716,'722',967,884,'101',689,'97',689,'111',689,'99":-',716,'528',608,'528',882,'ic:0.',884,'111',689,'101',689,'97',689,'46',764,'44":-0.',774,'444',608,'5',967,'0278,',658,'124}}],[1',967,'0278}],[0.','5',600,'5,0.668],[0.5,0.668]],cmmi10:[[0.615',813,'139',',krn:{"61":-0.0556,"59":-0.111,"58":-0.111,"127":0.',774,'833',687,'127":0.167}}],[0.','763',813,1010,'krn:{"127":0.0833}}],[0.','694',687,1024,'742',813,'0757,',1028,'831',813,'0812,krn:{"61',907,'59":-0.0556,"58":-0.0556,"127":0.','0556}}],[0.','78',813,'0576,',1028,'583',813,'139',1020,1041,'667',720,1028,'612',813,'11,krn:{"61',907,1040,1041,'772',813,'0502,',1028,'64',967,'0037,','krn:{"127":',716,'566',',0.694,0.194,{ic:0.','0528,',1028,'518',882,'ic:0.0556}],[0.444',596,'0378,krn:{"',1040,1041,'406',629,'krn:{"127":0.0556}}],[0.','438',1070,'0738,',1028,'497',882,'ic:0.0359',',',1082,'469',596,1010,1028,'354',629,1082,'576',608,'583',600,'603',882,1067,716,'494',967,'0637,krn:{"',1040,'0278}}],[0.','438',1070,'046,',1067,'0.111}}],[0.','57',967,'0359}],[0.','517',882,1028,'571',967,'0359,krn:{"59',907,'58":-0.',1041,'437',967,'113,krn:{"',1040,1111,'54',967,'0359,',1067,716,'596,0.694,0.194,{',1028,'626',882,1082,'651',1070,'0359,',1067,1116,'622',967,1119,'466',629,1028,'591',',0.694,0,{',1028,'828',967,1014,'517',882,1028,'363,0.431,0.0972,{ic:0.0799,',1028,'654',882,1067,'0.0833}}],[1',679,'1',679,'1',679,'1',679,628,',0.464,-0.0363],[',628,1178,'0.5,0.465,-0.0347],[',1181,'0.5',608,'5',608,'5',608,946,610,946,610,946,',0.194',664,950,664,'431',610,'278,0.106],[',654,610,'778',',0.539,0.0391],[','0.5,0.75,0.25,{krn:{"1',907,'65',907,'77',907,'78',907,'89":0.0556,"90":-0.',1041,'778',1204,1181,'0.531',596,'0556,',1028,'75',687,'127":','0.','139}}],[0.','759',813,'0502,',1028,'715',813,'0715,krn:{"61',689,1040,774,'828',813,1010,1082,'738',813,'0576,',1028,'643',813,'139',1020,774,'786',720,1028,'831',813,'0812,krn:{"61',907,1040,1041,'44',813,'0785,',1067,1116,'555',813,'0962',1020,'167}}],[0.','849',813,'0715,krn:{"61',907,1040,1041,'681',687,1224,716,'97',813,'109,krn:{"','61',907,1040,774,'803',813,1281,'61',764,'61',689,1040,774,'763',813,1010,1028,'642',813,'139',1020,774,'791,0.683,0.194,{',1028,'759',813,'00773,',1028,'613',813,'0576,krn:{"61',907,1040,774,'584',813,'139,krn:{"61',689,1040,774,'683',813,1281,'59":-0.111,"',1127,'111,"61',907,1224,716,'583',813,'222',',krn:{"59":-0.167,"58":-0.167,"61":-0.111}}],[0.','944',813,'139',1334,'828',813,'0785,krn:{"61',764,'61',689,1040,774,'581',813,'222',1334,'683',813,'0715,krn:{"61',907,1040,774,'389,0.75],[0.389',637,'0.389',637,'1,0.358,-0.142],[',1361,'0.417',1156,1067,1116,'529',608,'429',600,'433',629,1082,'52',645,'89":0.0556,"90',907,'106":-0.111,"102":-0.167,"',1024,'466',629,1082,'49',1070,'108,krn:{"',1040,1268,'477',882,1089,',',1067,716,'576',645,'127":-',716,'345,0.66],[0.412,0.66,0.194,{ic:0.0572,krn:{"59',907,1127,1041,'521',596,'0315}],[0.298',596,'0197,',1028,'878',608,'6',608,'485',629,1082,'503',882,1028,'446',882,1089,',',1028,'451',967,1010,'krn:{"',1040,1041,'469',629,1082,'361,0.615,0,{',1028,'572',629,1067,716,'485',967,'0359,',1067,716,'716',967,'0269,',1028,'572',629,1067,716,'49',882,1089,',',1082,'465',967,'044,',1082,'322',629,1067,716,'384',882,1028,'636',882,1067,1116,'5,0.714,0,{ic:0.154}],[',628,596,'399}]],cmsy10:[[',653,628,',0.444,-0.0556],[',653,1181,653,'0.5,0.444,-0.0556],[',653,653,653,653,653,653,653,'1',637,1481,1481,'0.778',1178,'0.778,0.464,-0.0363','],[0.778,0.636,0.136',1496,1496,1496,1496,1496,'],[0.778',679,'0.778,0.483,-0.0169],[0.778',1204,'0.778',1204,'1',1204,'1',1204,'0.778',1204,'0.778',1204,'1',679,'1',679,'0.5',637,'0.5',637,'1',679,'1',637,'1',637,'0.778',1178,'1',679,'1',679,'0.611',637,'0.611',637,'1',679,'1',637,'1',637,'0.778',608,'275,0.556],[1',608,'667',1204,'0.667',1204,'0.889',637,'0.889',637,'0',637,'0',679,'0.556',600,'556',600,'667',608,'5',639,'722',600,'722',600,'778',600,'778',600,'611',600,'798',687,'48":0.','194}}],[0.657',813,'0304',',krn:{"48":0.',1226,'527',813,'0583',1586,1226,'771',813,'0278',1586,774,'528',813,'0894',1586,'111}}],[0.','719',813,'0993',1586,1602,'595',',0.683,0.0972,{ic:0.','0593',1586,1602,'845',813,'00965',1586,1602,'545',813,'0738,krn:{"48":',716,'678',1609,'185',1586,1268,'762',813,'0144',1586,1041,'69',687,1582,'139}}],[1.2',687,1582,1226,'82',813,'147',1586,774,'796',813,1595,1586,1602,'696',813,'0822',1586,774,'817,0.683,0.0972,{krn:{"48":',1116,'848',687,1582,774,'606',813,'075',1586,1226,'545',813,'254,krn:{"48":',716,'626',813,'0993',1586,774,'613',813,'0822,krn:{"48":',716,'988',813,'0822',1586,774,'713',813,'146',1586,1226,'668',1609,'0822',1586,774,'725',813,'0794',1586,1226,'667,0.556],[0.',1698,1698,1698,1698,'611',600,'611',600,'444',649,'444',649,'444',649,'444',649,'5',649,'5',649,'389',649,'389',649,'278',649,'5',649,'5',649,'611',649,'5',649,'278',637,'0.833,0.04,0.96],[0.75',574,'833',574,'417',1070,'111}],[0.',1698,'667,0.556',1496,1496,'],[0.444',637,'0.444',637,'0.444',637,'0.611',637,'0.778,0.694,0.13','],[',1754,'],[',1754,'],[',1754,']],cmex10:[[0.458',',0.04,1.16,{n:','16}],[0.458',1762,'17}],[0.417',1762,'104}],[0.417',1762,'105}],[0.','472',1762,'106}],[0.472',1762,'107}],[0.472',1762,'108}],[0.472',1762,'109}],[0.583',1762,'110}],[0.583',1762,1741,'472',1762,'68}],[0.472',1762,'69}],[0.333',',0,0.6,{delim:{','rep:12}}],[0.556',1788,'rep:13}}],[0.578',1762,'46}],[0.578',1762,'47}],[0.597',',0.04,1.76,{','n:18}],[0.597',1796,'n:19}],[0.736',',0.04,2.36,{n:','32}],[0.736',1800,'33}],[0.528',1800,'34}],[0.528',1800,'35}],[0.583',1800,'36}],[0.583',1800,'37}],[0.583',1800,'38}],[0.583',1800,'39}],[0.75',1800,'40}],[0.75',1800,'41}],[0.75',1800,'42}],[0.75',1800,'43}],[1.04',1800,'44}],[1.04',1800,'45}],[0.792',',0.04,2.96,{n:','48}],[0.792',1828,'49}],[0.583',1828,'50}],[0.583',1828,'51}],[0.639',1828,'52}],[0.639',1828,'53}],[0.639',1828,'54}],[0.639',1828,'55}],[0.806',1828,'56}],[0.806',1828,'57}],[0.806',',0.04,2.96],[','0.806',1848,'1.28',1848,'1.28',1848,'0.811',1796,'n:30}],[0.811',1796,'n:31}],[0.875',1796,'delim:{top:','48,bot:64,rep:66}}],[0.875',1796,1861,'49,bot:65,','rep:67}}],[0.','667',1796,1861,'50,bot:52,rep:54}}],[0.667',1796,1861,'51,bot:53,rep:55}}],[0.667',1796,'delim:{bot:','52,rep:54}}],[0.667',1796,1875,'53,rep:55}}],[0.667',1788,'top:50,rep:54}}],[0.667',1788,'top:51,rep:55','}}],[0.889,0,0.9,{delim:{top:','56,mid:60,bot:58,rep:62',1884,'57,mid:61,bot:59,rep:62',1884,'56,bot:58,rep:62',1884,'57,bot:59,rep:62','}}],[0.889,0,1.8,{delim:{rep:','63',1892,'119}}],[0.889,0,0.3,{delim:{','rep:62}}],[0.','667',1788,'top:120,','bot:121,rep:63}}],[0.','875',1796,1861,'56,bot:59,',1896,'875',1796,1861,'57,bot:58,',1896,'875',1788,'rep:66}}],[0.875',1788,1866,'611',1796,'n:28}],[0.611',1796,'n:29','}],[0.833,0,1,{n:','71}],[1.11',',0.1,1.5],[','0.472,0,1.11,{ic:0.194,n:','73}],[','0.556,0,2.22,{ic:0.444}],[1.11,0',',1,{n:75}],[1.51,0','.1,1.5],[1.11,0',',1,{n:77}],[1.51,0',1928,',1,{n:79}],[1.51',1923,'1.06,0,1,{n:88}],[0.944,0,1,{n:89}],[',1924,'90',1921,'91',1921,'92',1921,'93',1921,'94',1921,'95}],[1.44',1923,'1.28',1923,1926,1928,1928,1928,1928,'.1,1.5],[0.944,0,1,{n:97}],[1.28',1923,'0.556,0.722,0,{n:','99','}],[1,0.75,0,{n:','100}],[1.44,0.75],[',1956,'102',1958,'103}],[1.44,0.75],[0.472',1796,'n:20}],[0.472',1796,'n:21}],[0.528',1796,'n:22}],[0.528',1796,'n:23}],[0.528',1796,'n:24}],[0.528',1796,'n:25}],[0.667',1796,'n:26}],[0.667',1796,'n:27}],[1',1762,'113}],[1',1796,'n:114}],[1',1800,'115}],[1',1828,'116}],[1.06,0,1.8,{',1861,'118,bot:116,rep:117}}],[1.06,0,0.6],[1.06,0.04,0.56],[0.778',1788,'top:126,','bot:127,rep:119','}}],[0.667',1788,1899,'rep:63}}],[0.667',1788,1900,'45,0.12],[0.',1999,1999,1999,'778',1788,1991,'rep:119}}],[0.778',1788,1992,'}}]],cmti10:[[0.627',813,'133}],[0.818',574,'767',813,'094}],[0.692',574,'664',813,'153}],[0.743',813,'164}],[0.','716',813,'12}],[0.','767',813,1741,'716',813,'0599}],[0.767',813,1741,'716',813,'103}],[0.','613',1070,'212,krn:{"39":0.104,"63":0.104,"33":0.104,"41":0.104,"93":0.104},lig:{"105":',598,'562',1070,2035,'588',1070,2035,'882',1070,2035,'894',1070,2035,'307',967,'0767}],[0.332',882,'ic:0.0374}],[0.511',600,'511',596,'0969','}],[0.511,0.','628,0,{ic:0.083}],[0.511',596,'108',2061,'562,0,{ic:0.',2035,'831',600,'46,0,0.17],[0.537',1070,1769,'716',967,'0751}],[0.716',967,'0751',2061,'528,0.0972,{ic:0.0919}],[0.883',813,2024,'985',813,2024,'767,0.732,0.0486,{ic:0.094}],[0.256',629,630,'256,"76":-0.321}}],[0.307',596,'124,lig:{"96":60}}],[0.514',596,'0696}],[0.818',1070,'0662}],[0.769',600,'818,0.75,0.0556',',{ic:0.136}],[0.','767',596,'0969}],[0.307',596,'124,krn:{"63":0.102,"33":0.102',647,'409',',0.75,0.25,{ic:0.162}],[0.','409,0.75,0.25,{ic:0.0369',2061,'75,0,{ic:0.149}],[0.767,0.562,0.0567,{ic:0.0369}],[0.307,0.106',610,'358',967,'0283,',658,'123}}],[0.307,0.106],[0.511',2105,'511,0.644,0',',{ic:0.136}],[0.511,0.644,0',2117,2117,2117,'.194',2117,2117,2117,'.194',2117,2117,2097,'307',967,'0582}],[0.307',882,'ic:0.0582}],[0.307,0.5,0.194,{ic:0.0756}],[0.767,0.367,-0.133,{ic:0.0662',2061,'5',610,'511',596,'122,lig:{"96":62}}],[0.767',596,'096}],[0.743',687,'110','":-0.0256,"','108',2144,'114',2144,'117',2144,'109',2144,'116',2144,'105',2144,'67',2144,'79',2144,'71',2144,'104',2144,'98',2144,'85',2144,'107',2144,'118',2144,'119',2144,'81',2144,'84":-0.0767,"89":-0.0767,"86":-0.102,"87":-0.102,"101":-0.0511,"97":-0.0511,"111":-0.0511,"100":-0.0511,"99":-0.0511,"103":-0.0511,"113":-0.0511}}],[0.','704',813,2035,'716',813,'145}],[0.755',813,'094,krn:{"88',2144,'87',2144,'65',2144,'86',2144,'89":-0.0256}}],[0.678',813,2024,'653',813,'133,krn:{"111','":-0.0767,"','101',2199,808,'0767,"114',2199,'97',2199,'65":-0.102,"79',2144,'67',2144,'71',2144,'81":-0.0256}}],[0.','774',813,'0872}],[0.743',813,2021,'386',813,'158}],[0.525',813,'14}],[0.769',813,'145,krn:{"79',2144,'67',2144,'71',2144,2213,'627',687,2177,'897',813,2021,'743',813,2021,'767',813,'094,krn:{"88":-0.0256,"87":-0.0256'],
  [',"65','":-0.0256,"','86',1,'89','":-0.0256}}],[0.','678,0.683',',0,{ic:0.','103',',krn:{"','65":-0.0767}}],[0.','767,0.683',',0.194,{ic:0.','094}],[0.729,0.683',7,'0387',9,'110',1,'108',1,'114',1,'117',1,'109',1,'116',1,'105',1,'67',1,'79',1,'71',1,'104',1,'98',1,'85',1,'107',1,'118',1,'119',1,'81',1,'84','":-0.0767,"','89',52,'86','":-0.102,"','87',56,'101":-0.0511,"97":-0.0511,"111":-0.0511,"100":-0.0511,"99":-0.0511,"103":-0.0511,"113":-0.0511}}],[0.','562,0.683',7,'12}],[0.','716,0.683',7,'133',9,'121',52,'101":-0.0767,"111":-0.0767,"114":-0.0767,"97":-0.0767,"117":-0.0767,"65":-0.0767}}],[0.','743,0.683',7,'164}],[0.743,0.683',7,'184',9,'111',52,'101',52,'117',52,'114',52,'97',52,'65',56,'79',1,'67',1,'71',1,'81',5,'999,0.683',7,'184',9,10,'743,0.683',7,'158',9,'79',1,'67',1,'71',1,'81',5,'743,0.683',7,'194',9,69,'613,0.683',7,'145','}],[0.307,0.','75,0.25',',{ic:0.188}],[0.514',',0.694',7,'169',121,122,',{ic:0.105','}],[0.511,0.','694',7,'0665',121,'668',7,'118',121,'694',7,'124,lig:{"96":92}}],[0.511,0.431',7,'0767}],[0.','46',124,7,'0631',9,59,'46,0.','431',7,'0565',9,59,'511',124,7,'103',9,'108":0.0511}}],[0.',150,'431',7,'0751',9,59,'307',124,12,'212',9,'39":0.104,"63":0.104,"33":0.104,"41":0.104,"93":0.104},lig:{"105":','12,"102":11,"108":13}}],[0.',150,'431',12,'0885',130,'694',7,'0767',121,'655',7,'102',121,'655',12,'145}],[0.46',124,7,'108}],[0.','256',124,7,'103',9,161,'818,0.431',7,143,'562,0.431',7,182,9,'39":-0.102}}],[0.511,0.431',7,'0631',9,59,'511,0.431',12,'0631',9,59,150,'431',12,'0885}],[0.','422,0.431',7,'108',9,59,'409,0.431',7,'0821}],[0.332,0.615',7,'0949}],[0.537,0.431',7,143,150,'431',7,193,'664,0.431',7,'108',9,161,'464,0.431',7,62,'486,0.431',12,220,'409,0.431',7,'123',130,'431',7,'0921',',lig:{"45":124}}],[1.','02,0.431',7,254,130,'694',7,'122',130,'668',7,'116',130,'668',7,'105}]],cmbx10:[[0.692',',0.686],[0.','958',271,'894',271,'806',271,'767',271,'9',271,'831',271,'894',271,'831',271,'894',271,'831',271,'671',124,7,'109,krn:{"39":0.109,"63":0.109,"33":0.109,"41":0.109,"93":0.109},lig:{"105":','14,"108":15}}],[0.639',',0.694],[0.','639',297,'958',297,'958',297,'319',',0.444],[0.','351',',0.444,0.194','],[0.575,0.','694',308,'694',308,'632',308,'694',308,'596],[0.869',297,'511,0,0.17],[0.597',297,'831',305,'894,0.444',308,'542,0.0972],[1.04,0.686],[1.17',271,'894,0.735,0.0486],[0.319',',0.444,0,{krn:{"','108":-0.319,"76":-0.378}}],[0.35',',0.694,0,{lig:{"96":','60}}],[0.603',297,'958',124,',0.194',308,'75,0.0556],[0.','958,0.',337,'894',297,'319',',0.694,0,{krn:{"','63":0.128,"33":0.128},lig:{"39":34}}],[0.447,0.',122,'],[0.447,0.',122,308,'75],[0.894,0.633,0.133],[','0.319,0.156',',0.194],[0.','383,0.444,0,{lig:{"45":123}}],[',350,308,122,308,'644',308,'644',308,'644',308,'644',308,'644',308,'644',308,'644',308,'644',308,'644',308,'644],[0.319',305,'319',307,'],[0.35,0.5',351,'894,0.391,-0.109],[0.543,0.5',351,'543',330,'62}}],[0.894',297,'869',',0.686,0,{krn:{"','116','":-0.0319,"','67',390,'79',390,'71',390,'85',390,'81',390,'84":-0.0958,"89":-0.0958,"86":-0.128,"87":-0.128}}],[','0.818',271,'831',271,'882',388,'88',390,'87',390,'65',390,'86',390,'89','":-0.0319}}],[0.','756',271,'724,0.686,0,{','krn:{"111":-0.0958,"101":-0.0958,"117":-0.0958,"114":-0.0958,"97":-0.0958,"65":-0.128,"79":-0.0319,"67":-0.0319,"71":-0.0319,"81":-0.0319}}],[','0.904',271,'9',271,'436',388,'73','":0.0319}}],[0.','594',271,'901',388,'79',390,'67',390,'71',390,'81',417,'692',388,401,'1.09',271,'9',271,'864',388,'88',390,'87',390,'65',390,'86',390,'89',417,'786',388,'65":-0.0958,"111',390,'101',390,'97',390,'46":-0.0958,"44":-0.0958}}],[0.','864,0.686',351,'862',388,'116',390,'67',390,'79',390,'71',390,'85',390,'81',390,401,'0.639',271,'8',388,'121',390,'101":-0.0958,"111":-0.0958,"114":-0.0958,"97":-0.0958,"65":-0.0958,"117":-0.0958}}],[0.','885',271,'869,0.686',7,'016,',421,'1.19,0.686',7,'016,',421,'0.869',388,'79',390,'67',390,'71',390,'81',417,'869,0.686',7,'0287',9,493,'703',271,'319,0.',122,'],[0.603',297,521,122,308,'694],[0.319',297,'319',330,'92}}],[0.559',328,'118',390,'106":0.0639,"121',390,'119',417,'639',124,',0',',{krn:{"101":0.0319,"111":0.0319,"120":-0.0319,"100":0.0319,"99":0.0319,"113":0.0319,"118":-0.0319,"106":0.0639,"121":-0.0319,"119":-0.0319}}],[0.','511',328,'104',390,'107',417,'639',297,'527',305,'351',124,7,295,174,'575,0.444',12,'016',9,'106',429,'639',343,'116',390,'117',390,'98',390,'121',390,'118',390,'119',417,'319',297,'351',124,351,'607',343,'97":-0.0639,"101',390,'97',390,'111',390,'99',417,'319',297,'958',328,'116',390,'117',390,'98',390,'121',390,'118',390,'119',417,'639',328,'116',390,'117',390,'98',390,'121',390,'118',390,'119',417,'575,0.444,0',543,'639',307,543,'607',307,'],[0.474',305,'454',305,'447,0.635,0,{krn:{"121',390,'119',417,'639',328,'119',417,'607,0.444',7,'016',9,'97":-0.0639,"101',390,'97',390,'111',390,'99',417,'831,0.444',7,'016',9,'101',390,'97',390,'111',390,'99',417,'607',305,643,12,'016',9,'111',390,'101',390,'97',390,469,'511,0.444',308,'444',7,'0319',255,'15,0.444',7,'0319}],[0.575',124,308,'694',308,'694]]};','jsMath.Img','={fonts:[50,60,70,85,100,120,144,173,207,249,298,358,430],w:{"50":6.9,"60":8.3,"70":9.7,"85":11.8,"100":13.9,"120":16.7,"144":20,"173":24,"207":28.8,"249":34.6,"298":41.4,"358":49.8,"430":59.8},best:4,update:{},factor:1,loaded:0,SetFont',':function(','_a2){for(var _a3 in _a2){if(!','this.update[_a3',']){',698,']=[];}',698,']=',698,'].concat(_a2[_a3]);}},AddFont',696,'_a4,def){if(!',694,'[_a4]){',694,'[_a4]={};}','jsMath.Add(jsMath.','Img[_a4],def);},UpdateFonts',':function(){','var _a6=this.update;','if(!this.loaded){','return;}var ','_a7=this[','jsMath.Img.fonts','[this.best]];','for(var _a8 in _a6){','for(var i=0;i<','_a6[_a8].length;i++){var c=_a6[_a8][i];if(c=="all"){for(c in ','jsMath.TeX[','_a8]){',724,'_a8][c].img','={};}}else{',724,727,'={};}}}this.update={};},BestSize',714,'var w=jsMath.em*this.factor;var m=','this.w[this.fonts[','0]];for(var i=1;i<','this.fonts','.length;i++){','if(w<(',734,'i]]+2*m)/3){','return ','i-1;}m=',734,'i]];}',741,'i-1;},Scale',714,716,'return;}this.best=this.BestSize();this.em=',694,'.w[',736,720,'this.scale','=(jsMath.em/this.em);','if(Math.abs(',754,'-1)<0.12){',754,'=1;}},URL',696,'_ae,_af,C){var _b1=(','jsMath.Controls.cookie.','alpha)?"/alpha/":"/plain/";if(C==null){C="def.js";}else{C="char"+C+".png";}if(_af!=""){_af+="/";}','return this.','root+_ae+_b1+_af+C;},LoadFont',696,'_b2){',716,'this.Init();}jsMath.Setup.Script(this.URL(_b2,""));},Init',714,'if(',763,'print||',763,'stayhires','){',763,'print=',763,776,';this.factor*=3;if(!','jsMath.Controls.','isLocalCookie||!jsMath.Global.isLocal){',783,'SetCookie(0);}if(','jsMath.Browser.','alphaPrintBug){',763,'alpha=0;}}var _b3="0123456789ABCDEF";this.HexCode=[];',722,'128;i++){var h=Math.floor(i/16);var l=i-16*h;this.HexCode[i]=_b3.charAt(h)+_b3.charAt(l);}this.loaded=1;}};jsMath.HTML={Em',696,'m){var n=5;if(m<0){n++;}',756,'m)<0.000001){m=0;}var s=String(m);s=s.replace(/(\\.\\d\\d\\d).+/,"$1");',741,'s+"em";},Spacer',696,'w){if(w==0){return "";}',741,787,'msieSpaceFix+"<','span class=\\"spacer\\" style=\\"margin-','left:"+this.Em(','w)+"\\"></span>";},Blank',696,'w,h,d,_be){var _bf="";var _c0="";if(_be){_c0+="border-',805,'w)+" solid;";if(',787,'widthAddsBorder){w=0;}}if(w==0){if(',787,'blankWidthBug){_c0+="width:1px;";_bf="<',804,'right:-1px\\"></span>";}}else{_c0+="width:"+this.Em(w)+";";}if(d==null){d=0;}if(h){var H=this.Em(h+d);if(_be&&h*jsMath.em<1.5){H="1px";h=1/jsMath.em;}_c0+="height:"+H+";";}if(',787,'mozInlineBlockBug){d=-h;}if(',787,'msieBorderBug&&!_be){d-=jsMath.d;}if(d){_c0+="','vertical-align:"+','this.Em(-d);}',741,'_bf+"<span class=\\"blank\\" ','style=\\""+','_c0+"\\"></span>";},Rule',696,'w,h){if(h==null){h=jsMath.TeX.default_rule_thickness;}',765,'Blank(w,h,0,1);},Class',696,'_c4,_c5){return "<span class=\\""+_c4+"\\">"+_c5+"</span>";},Place',696,'_c6',',x,y){if(Math.abs(x)<0.0001){x=0;}if(Math.abs(y)<0.0001){y=0;}','if(x||y){var _c9','="<span style=\\"position',': relative',';";if(x){_c9+=" margin-',805,'x)+";";}if(y){_c9+=" ','top:"+this.Em','(-y)+";";}_c6=_c9+"\\">"+_c6','+"</span>";}',741,'_c6;},PlaceSeparateSkips',696,'_ca',835,'if(y){_ca',837,838,'; ',842,'(-y)+";"+"\\">"+_ca',844,'if(x){_ca=this.Spacer(x)+_ca',';}return ','_ca;},PlaceAbsolute',696,'_cd',835,'_cd',837,':absolute','; ',805,'x)+"; "+"',842,'(y)+";\\">"+_cd+"&nbsp;</span>";',741,'_cd;},Absolute',696,'_d0,w,h,d,y,H){if(y!="none"){',756,'y)<0.0001){y=0;}_d0',837,865,'; "+"top:"+','jsMath.HTML.','Em(y)+"; left:0em',';\\">"+_d0','+"&nbsp;"+"</span>";}if(d=="none"){d=0;}_d0+=this.Blank(w,h-d,d);if(',787,'msieAbsoluteBug){_d0',837,':relative',882,844,'_d0',837,887,';"+" width: "+',880,'Em(w)+";"+" height: "+',880,'Em(H)+";"+',787,'msieInlineBlockFix+"\\">"+_d0+"</span>";',741,'_d0;}};','jsMath.Box','=function(','_d6,_d7,w,h,d){if(d==null){d=jsMath.d;}this.type="typeset";this.w=w;this.h=h;this.d=d;this.bh=h;this.bd=d;this.x=0;this.y=0;','this.html=','_d7;this.format=_d6;};',712,'Box,{defaultH:0,Null:','new jsMath.Box("','null","",0,0,0),Text',696,'_db,_dc,_dd,_de,a,d){var _e1=','jsMath.Typeset.AddClass(','_dc,_db);_e1=','jsMath.Typeset.','AddStyle(','_dd,_de,_e1);var BB','=jsMath.EmBoxFor(','_e1);var TeX=',915,'TeX(_dd,_de);var bd=((_dc=="cmsy10"||_dc=="cmex10")?BB.h-TeX.h:TeX.d*BB.h/TeX.hd);','var box=',909,'text",_db,BB.w,BB.h-bd,bd);box.style=_dd;box.size=_de;','box.tclass','=_dc;if(d!=null){box.d=d','*TeX.scale;}else{box.','d=0;}if(a==null||a==1){box.h=0.9*TeX.M_height;}else{box.h=1.1*TeX.x_height+TeX.scale*a;}','return box;},','TeX',696,'C,_e7,_e8,_e9){var c=',724,'_e7][C];if(','c.d==null){c.d=0;}','if(c.h','==null){c.','h=0',';}if(c.img!=null','&&c.c!=""){this.TeXIMG(_e7,C,',915,'StyleSize(_e8,_e9));}var _eb=',915,'TeX(_e8,_e9).scale;var h=c.h+',724,'_e7].dh;',922,909,'text",c.c,c.w*_eb,h*_eb,c.d*_eb);box.style=_e8;box.size=_e9;if(c.tclass){',925,'=c.tclass;if(c.img){box.bh=c.img.bh;box.bd=c.img.bd;}else{box.bh=_eb*jsMath.h;box.bd=_eb*jsMath.d;}}else{',925,'=_e7;box.bh=_eb*',724,'_e7].h;box.bd=_eb*',724,'_e7].d;if(',787,'msieFontBug&&box.html.match(/&#/)){box.html+="<span style=\\"display:none\\">x</span','>";}}',929,'TeXfallback',696,'C,_ef,_f0,_f1','){var c=',724,'_ef][C];if(!c.tclass){c.tclass=_ef',939,'){',765,'TeXnonfallback(',964,');}if(c.h!=null&&c.a',937,'a=c.h-1.1*jsMath.TeX.x_height;}var a=c.a;var d=c.d;',922,'this.Text(c.c,c.tclass,_f0,_f1,a,d);var _f6=',915,'TeX(_f0,_f1).scale;if(c.bh!=null){box.bh=c.bh*_f6;box.bd=c.bd*_f6;}else{var h=box.bd+box.bh;var _f8=',913,925,',box.html);_f8=',915,916,'_f0,_f1,_f8);box.bd',918,'_f8+',880,'Blank(1,h)).h-h;box.bh=h-box.bd;if(_f6==1){c.bh=box.bh;c.bd=box.bd;}}if(jsMath.',959,'>";}',929,'TeXIMG',696,'_f9,C,_fb){var c=',724,'_f9][C];if(c.img.size!=null&&c.img.size==_fb&&c.img.best!=null&&c.img.best==','jsMath.Img.best','){',717,'_fd=(',694,'.scale!=1);var id=',998,'+_fb-4;if(id<0){id=0;_fd=1;}else{if(id>=',719,'.length){','id=',719,'.length-1',';_fd=1;}}var _ff=',694,'[',719,'[id]];var img=_ff[_f9][C];var _101=1/',694,'.w[',719,'[id]];if(id!=',998,'+_fb-4){if(c.w!=null){_101=c.w/img[0];}else{_101*=',719,'[_fb]/',719,'[4]*',719,'[',998,']/',719,'[id];}}var w=img[0]*_101;var h=img[1]*_101;var d=-img[2]*_101;var v;var _106=(c.w==null||Math.abs(c.w-w)<0.01)?"":" margin-right:"+',880,'Em(c.w-w)+";";var _107="";C=',694,'.HexCode[C];if(!_fd&&!',763,'scaleImg){if(2*w<h||(',787,'msieAlphaBug&&',763,'alpha)){_107="height',':"+(img[1]*',787,'imgScale',')+"px;";}_107+=" width:"+(img[0]*',787,1044,')+"px;";v=-img[2]+"px";}else{if(2*w<h||(',787,'msieAlphaBug&&',763,1041,':"+',880,'Em(h*',787,1044,')+";";}_107+=" width:"+',880,'Em(w*',787,1044,')+";";v=',880,'Em(d);}var _108=(Math.abs(d)<0.01&&!',787,'valignBug)?"":" ',821,'v+";";var URL=',694,'.URL(_f9,',719,'[id],C);if(',787,'msieAlphaBug&&',763,'alpha){','c.c="<img src=\\""+','jsMath.blank+"\\" "+"',825,787,'msieCenterBugFix+_107+_108+_106','+" filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src="+"\'"+URL+"\', sizingMethod=\'scale\'"+");\\" />";}else{',1078,'URL+"\\" ',825,787,1082,'+"\\" />";}c.tclass="normal";c.img.bh=h+d;c.img.bd=-d;c.img.size=_fb;c.img.best=',998,';},Space',696,'w){',741,909,'html",',880,'Spacer(w),w,0,0);},Rule',696,828,'var html=',880,'Rule(w,h);',741,909,'html",html,w',',h,0);},GetChar',696,'code,font){var c=',724,'font][code];','if(c.img!=null){this.TeXIMG(font,code',',4);}if(c.tclass',937,'tclass=font;}if(!c.computedW){c.w',918,913,'c.tclass,c.c)).w',';if(c.h==null){c','.h=jsMath.Box.defaultH;}if(',935,'c.computedW=1',858,'c;},DelimBestFit',696,'H,c,font,','_114){if(c==0&&font','==0){return null;}','var C;var h;','font=jsMath.TeX.fam[','font];var ','isSS=(_114.charAt(1)=="S");var isS=(_114.charAt(0)=="S");while(c!=null){C=',724,'font][c];','if(C.h==null){C',1120,'C.d==null){C.d=0;}h=C.h+C.d;if(C.delim','){return [c,font',',"",H];}if(isSS&&0.5*h>=H',1138,',"SS",0.5*h];}if(isS&&0.7*h>=H',1138,',"S",0.7*h];}if(h>=H||C.n==null',1138,',"T",h];}c=C.n',858,'null;},DelimExtendRelative',696,1126,'a,_11d){var C=',724,1134,'var top=this.GetChar(C.delim.top?C.delim.top:C.delim.rep,font);var rep=this.GetChar(C.delim.rep,font);var bot=this.GetChar(C.delim.bot?C.delim.bot:C.delim.rep,font);','var ext=',913,'rep.tclass,rep.c);','var w=rep.w;var h=','rep.h+rep.d',';var y;var dx;','if(C.delim.mid){var mid=this.GetChar(C.delim.mid,font);var n=Math.ceil((H-(top.h+top.d)-(mid.h+mid.d',')-(','bot.h+bot.d','))/(2*(',1158,')));H=2*n*(',1158,')+(top.h+top.d)+(','mid.h+mid.d',')+(',1162,');if(_11d){y','=0;}else{','y=H/2+a;}var Y=y;',1101,880,'Place(',913,'top.tclass,top.c),0,','y-top.h)+',880,1176,913,'bot.tclass,bot.c),-(','top.w+bot.w)/2,y-(H-bot.d))+',880,1176,913,'mid.tclass,mid.c','),-(bot.w+mid.w)/2,y-(H+mid.h-mid.d)/2);dx=(w-mid','.w)/2;if(Math.abs(dx)<0.0001){dx=0;}if(dx){html+=jsMath.HTML.Spacer(dx);}y-=top.h+top.d+rep.h;for(var i=0;i<n;i++){html+=jsMath.HTML.Place(ext,-w,y-i*h);}','y-=H/2-rep.h/2;',722,'n;i++){','html+=',880,1176,'ext,-w,y-i*h);}}','else{var n=Math.ceil((H-(top.h+top.d)-(bot.h+bot.d','))/(',1158,'));if(top.h+top.d<0.9*(',1158,')){n=Math.max(1,n);}H=n*(',1158,1167,1162,');if(_11d){y',1172,'y=H/2+a;}var Y=y;',1101,880,1176,913,1178,'y-top.h);dx=(w-top',1190,1194,880,1176,913,1183,'w+bot.w)/2,Y-(H-bot.d));}if(_11d){h=top.h;}else{h=H/2+a;}','var box=new jsMath.Box("html",html,rep.w,h,H-h);box.bh=jsMath.TeX[font].h;box.bd=jsMath.TeX[font].d;return box;},','DelimExtendAbsolute',696,1126,'a,_136){var Font=',724,1131,'C=Font[c];var html;',1153,1160,'-0.05)-(',1162,'-0.05))/(','2*(','rep.h+rep.d-0.05',')));H=2*n*(',1237,1167,1168,'-0.05)+(',1162,'-0.05);html=','jsMath.HTML.PlaceAbsolute(',913,1178,'0);var h=',1237,';var y=top.d-0.05+rep.h;var ext=',913,'font,rep.c);',722,'n;i++){',1194,1245,'ext,0,y+i*h);}',1194,1245,913,1188,'),0,y+n*h-rep.h+mid.h);y+=n*h+',1168,'-0.05;',722,'n;i++){',1194,1245,'ext,0,y+i*h);}',1194,1245,913,'bot.tclass,bot.c),0,y+n*h-rep.h+bot.h);}',1198,1235,1237,'));H=n*(',1237,1167,1162,'-0.05);html=',1245,913,1178,'0);var h=',1237,';var y=top.d-0.05+rep.h;var ext=',913,1156,722,'n;i++){',1194,1245,'ext,0,y+i*h);}',1194,1245,913,1273,'var w=top.w;if(_136){h=top.h;y',1172,'h=H/2+a;y=h-top.h;}html=',880,'Absolute(html,w,','Font.h,"none",-y,top.h);',1223,'Delimiter',696,'H,_14c,_14d,_14e){var size=4;var TeX=',915,'TeX(_14d,size);if(!_14c){',765,'Space(TeX.nulldelimiterspace);}','var ','CFSH=this.DelimBestFit(H,_14c[','2],_14c[1],_14d);if(CFSH==null||CFSH[3]<H){',1314,'4],_14c[3],_14d);}if(CFSH==null){',765,1312,'if(CFSH[2]==""){',765,'DelimExtend(H,','CFSH[0],CFSH[1],','TeX.axis_height',',_14e);}',922,902,'.TeX(',1323,'CFSH[2],size',').Styled();if(_14e){box.y=-',724,'CFSH[1]].dh',927,'y=-((box.h+box.d)/2-box.d-',1324,');}',756,'box.y)<0.0001){box.y=0;}if(box.y','){box=jsMath.Box.SetList','([box],',1330,');}',929,'GetCharCode',696,'code){var ',1130,'code[0]];var Font=',724,1131,'c=Font[code[1]];',1112,'[1],4);}if(c.w',937,'w',918,913,1118,';}if(c.font',937,'font=font',858,'c;},AddClass',696,'_157,html',',font){if(_157==null){_157=font',858,913,1366,');},LayoutRelative',696,'size,_15b,_15c,_15d,_15e,_15f){if(_15c==null){_15c=[];}if(_15d==null){_15d=[];}if(_15e==null){_15e=[];}var _160=jsMath.sizes[size]/100',';var W=[];var H=[];var D=[];var ','_164=-1000;var bh=_164;var bd=_164',';var i;var j;var row;for(i=0;i<','_15b',737,'if(_15e[i]==null){_15e[i]=0;}row=_15b','[i];H[i]=jsMath.h*','_160',';D[i]=jsMath.d*','_160',';for(j=0;j<','row.length;j++){row[j]=row[j].Remeasured();if(row[j].h>H[i]){H[i]=row[j].h;}if(row[j].d>D[i]){D[i]=row[j].d;}if(j>=W.length){W[j]=row[j].w;}else{if(row[j].w>W[j]){W[j]=row[j].','w;}}if(row[j].bh>bh){bh=row[j].bh;}if(row[j].bd>bd){bd=row[j].bd;}}}if(_15e[_15b','.length]==null){','_15e[_15b.length]=0;}if(bh==_164){bh=0;}if(bd==_164){bd=0;}','var HD=(jsMath.hd-0.01)*','_160;var dy=(_15f||1)*_160/6;','var html="";var ','pW=0;var cW=0;var w;var h;var y;var box;var _173;var _174',';for(j=0;j<W.length;j++){','_173=[];y=-H[0]-_15e[0];pW=0;for(i=0;i<_15b',737,'_174=_15b[i][j];if(_174&&_174.format!="null"){','if(_15c[j]=="','l"){w',1172,1397,'r"){w=W[j]-_174.w;}else{w=(W[j]-_174.w)/2;}}_174.x=w-pW;pW=_174.w+w;_174.y=y;_173[_173.length]=_174;}if(i+1<_15b',1007,'y-=','Math.max(HD,D[i]+H[i+1])+dy+','_15e[i+1];}}if(_15d[j]==null){_15d[j]=_160;}if(_173.length>0',1340,'(_173,"T",size);',1194,880,1176,'box.html,cW,0);cW=W[j]-box.w+_15d[j];}else{cW+=_15d[j];}}w=-_15d[W',1010,'];y=(H',1010,')*dy+_15e[0];for(i=0;i<W',737,'w+=W[i]+_15d[i];}for(i=0;i<H',737,'y+=Math.max(HD,H[i]+D[i])+','_15e','[i+1];}h=y/2+jsMath.TeX.axis_height;var d=y-h;',1194,880,'Spacer(cW-_15d[W',1010,']+_160/6);html=',880,1176,'html,_160/6,h);box=',909,1106,'+_160/3,h,d);box.bh=bh;box.bd=bd;',929,'LayoutAbsolute',696,'size,_177,_178,_179,_17a,_17b){if(_178==null){_178=[];}if(_179==null){_179=[];}if(_17a==null){_17a=[];}var _17c=jsMath.sizes[size]/100;',1389,'_17c;var dy=(_17b||1)*_17c/6',1374,'w=0;var h;var x;var y',1376,'_177',737,'if(_17a[i]==null){_17a[i]=0;}row=_177',1380,'_17c',1382,'_17c',1384,1385,'w;}}}}if(_17a[_177',1387,'_17a[_177.length]=0;}y=(H',1010,')*dy','+_17a[0];for(i=0;i<','H',737,1419,'_17a',1421,1391,'_18b;w=_17c/6',1393,'y=H[0]-h',1456,'_177',737,'_18b=_177[i][j];if(_18b&&_18b.format!="null"){','if(_178[j]&&_178[j]=="','l"){x',1172,1470,'r"){x=W[j]-_18b.w;}else{x=(W[j]-_18b.w)/2;}}',1194,1245,'_18b.html,w+x,y-Math.max(0,_18b.bh-jsMath.h*_17c));}if(i+1<_177',1007,'y+=',1404,'_17a[i+1];}}if(_179[j]==null){_179[j]=_17c;}w+=W[j]+_179[j];}w=-_179[W',1010,']+_17c/3;for(i=0;i<W',737,'w+=W[i]+_179[i];}html=',880,'Spacer(_17c/6',')+html+',880,1487,');if(',787,'spanHeightVaries){y=h-jsMath.h;}else{y=0;}html=',880,1303,'h+d,d,y,H[0]);',922,909,1106,'+_17c/3,h,d);',929,'InternalMath',696,'text,size){text=text.replace(/@\\(([^)]*)\\)/g,"<$1>");if(!text.match(/\\$|\\\\\\(/)){',765,'Text(text,"normal","T",size).Styled();}var i=0;var k=0;var c;var _192="";var _193=[];var _194;var html;var box;while(i<text',1007,'c=text.charAt(i++);if(c','=="$"){if(_192=="$"){','_194=jsMath.Parse(text.slice(k,i-','1','),null,size);if(_194.error){_193[_193.length]=this.Text(_194.error,"error","T",size,1,0.2);}else{_194.Atomize();_193[_193.length]=_194.mlist.Typeset("T",size).Styled();}_192="";k=i',';}else{','_193[_193.length]=this.Text(text.slice(k',',i-1','),"normal","T",size,1,0.2);','_192="$";k=i;}}else{if(c=="\\\\"){',1508,'=="("&&_192==""){',1514,',i-2',1516,'_192=")";k=i;}else{if(c==")"&&_192==")"){',1510,'2',1512,';}}}}}',1514,1516,765,'SetList(_193,"T",size);},Set',696,'box',',_198,size',',_19a){if(box&&box.type){','if(box.type=="typeset"){',741,'box;}if(box.type=="mlist"){box.mlist.Atomize(_198,size);',741,'box.mlist.Typeset(_198,size);}if(box.type=="text"){box=this.Text(box.text,',925,1534,',box.ascend||null,box.descend||null',');if(_19a!=0){box.Styled();}return box;}','box=this.TeX(box.c,box.font',1534,1544,741,902,'.Null;},SetList',696,'_19b,_19c,size){var _19e=[];var box;',722,'_19b',737,'box=_19b[i];',1536,'box=','jsMath.mItem','.Typeset(box);}_19e[_19e.length]=box;}var _1a1=new jsMath.Typeset(_19e);',741,'_1a1.Typeset(_19c,size);}});','jsMath.Package(jsMath.','Box,{Styled',714,'if(this.format=="text"){',905,913,'this.tclass',',this.html);',905,915,916,'this.style,this.size',1570,'delete this.','tclass;',1576,'style;this.format="html";}',741,'this;},Remeasured',714,'if(this.w>0){this.w',918,'this.html).w',858,'this;}});',1559,903,'type,def){this.type=type;jsMath.Add(this,def);};',712,'mItem,{Atom',696,'type,_1a5','){return new jsMath.mItem','(type,{atom:1,nuc',':_1a5});},TextAtom',696,'type,text,_1a8,a,d){var atom=new ',1559,1596,':{type:"text",text:text,tclass:_1a8}});if(a','!=null){atom.nuc.','ascend=a;}if(d',1603,'descend=d',858,'atom;},TeXAtom',696,'type,c,font',1595,1596,':{type:"TeX",c:c,font:font}});},Fraction',696,'name,num,den,_1b2,left,_1b4',1595,'("fraction",{from:name,num:num,den:den,thickness:_1b2,left:left,right:_1b4});},Space',696,'w',1595,'("space",{w:w});},Typeset',696,'box',1595,'("ord",{atom:1,nuc:box});},HTML',696,'html',1595,'("html",{html:html});}});jsMath.mList',903,'list,font,size,_1bb){if(list){this.mlist=list;}else{this.mlist=[];}if(_1bb==null){_1bb="T";}if(size==null){size=4;}this.data={openI:null,overI:null,overF:null,font:font,','size:size,style:_1bb','};this.init={',1632,'};};',1563,'mList,{Add',696,'box){return (this.mlist[','this.mlist.length',']=box);},Get',696,'i){',765,'mlist[i];},Length',714,765,'mlist.length;},Last',714,'if(',1640,1128,765,'mlist[',1640,'-1];},Range',696,'i,j){if(j==null){j=',1640,858,'new jsMath.mList(this.mlist.slice(i,j+1));},Delete',696,1658,'i;}if(','this.mlist.splice','){',1665,'(i,j-i+1);}else{var _1c2=[];for(var k=0;k<',1640,';k++){if(k<i||k>j){_1c2[_1c2.length]=this.mlist[k];}}this.mlist=_1c2;}},Open',696,'left){',922,'this.Add(new ',1559,'("boundary",{data:this.data}));var _1c6=this.data;this.data={};for(var i in _1c6){this.data[i]=_1c6[i];}',1576,'data.overI;',1576,'data.overF;this.data.openI=this.mlist.len'],
  ['gth-1;if(left!=null','){box','.left=left;}','return ','box;},Close',':function(','_1c8){if(_1c8!=null){_1c8=new ','jsMath.mItem','("boundary",{right:_1c8});}var atom;var open=this.data.openI;','var over=this.data.overI;var from=this.data.overF;','this.data=','this.mlist','[open].data;if(over){','atom=jsMath.mItem.Fraction(from.name,{type:"mlist",mlist:this.Range(open+1,over-1)},{type:"mlist",mlist:this.Range(over)},from.thickness,from.left,from.right);','if(_1c8){var _1cd','=new jsMath.','mList([',11,'[open],atom,_1c8]);atom=',7,'.Atom("inner','",{type:"mlist",mlist:','_1cd});}}else{var _1ce=open+1;if(_1c8){this.Add(_1c8);_1ce--;}atom=',7,'.Atom((_1c8)?"inner":"ord',21,'this.Range(_1ce)});}this.Delete(open,this.Length());',3,'this.Add(atom);},Over',':function(){',9,'var ',13,11,'=[atom];},Atomize',5,'_1d2',',size){var ','_1d4;var prev="";','this.style','=_1d2;','this.size','=size;for(var i=0;i<',11,'.length;i++){','_1d4=',11,'[i];_1d4.delta=0;if(_1d4.type=="choice"){',11,'=this.Atomize.choice(',39,',_1d4,i,',11,');i--;}','else{if(','this.Atomize[_1d4.type',']){var f=',55,'];f(',39,',',41,',_1d4,prev,this,i);}}prev=_1d4;}if(_1d4&&_1d4','.type=="bin"){','_1d4','.type="ord";}','if(',11,'.length>=2&&_1d4.','type=="boundary','"&&',11,'[0].',69,'"){this.','AddDelimiters','(_1d2,size);}},',75,5,'_1d8',37,'_1da=-10000;var h=_1da;var d=_1da;for(var i=0;i<',11,44,'var _1de=',11,'[i];if(_1de.atom||_1de.type=="box"){h','=Math.max(','h,_1de.nuc.h+_1de.nuc.y);d',87,'d,_1de.nuc.d-_1de.nuc.y);}}var TeX','=jsMath.TeX',';var a=','jsMath.Typeset.','TeX(_1d8,size).axis_height;var _1e1',87,'h-a,d+a);var H',87,'Math.floor(','TeX.integer','*_1e1/500)*TeX.delimiterfactor,',99,'*(2*_1e1-TeX.delimitershortfall))/',99,';var left=',11,'[0];var _1e4=',11,'[',11,'.length-1];left.nuc','=jsMath.Box.','Delimiter(H,','left.left',',_1d8);_1e4.nuc',111,112,'_1e4.right',',_1d8);left.type="open";left','.atom=1;delete ',113,';_1e4.type="close";_1e4',119,117,';},','Typeset',5,'_1e5',37,'_1e7',15,125,'(',11,');',3,'_1e7.',125,'(_1e5,size);}});','jsMath.Add(jsMath.','mList.prototype.Atomize,{style',5,'_1e8,size,_1ea,prev,_1ec){_1ec.style=_1ea.style;},size',5,'_1ed,size,_1ef,prev,_1f1){_1f1.size=_1ef.size;},phantom',5,'_1f2,size,_1f4){','var box','=_1f4.nuc',111,'Set(','_1f4.phantom',',_1f2',',size);','if(_1f4.h',1,'.Remeasured();','box.html','=','jsMath.HTML.','Spacer(','box.w);}else{',157,'="",box.w=0;}if(!_1f4.v){','box.h=box.d=','0;}','box.bd=box.bh=0;delete ',151,';_1f4.type="box";},smash',5,'_1f6,size,_1f8){',147,'=_1f8.nuc',111,150,'_1f8.smash',',_1f6,','size).Remeasured();',164,166,175,';_1f8.type="box";},raise',5,'_1fa,size,_1fc){_1fc.nuc',111,150,'_1fc.nuc,_1fa',',size);var ','y=_1fc.raise;_1fc.nuc.html=',159,'Place(_1fc.nuc.html,0,y);_1fc.nuc.h+=y;_1fc.nuc.d-=y;_1fc','.type="ord";','_1fc.atom=1;},lap',5,'_1fe,size,_200){',147,111,150,'_200.nuc,_1fe,',177,'var _202=[box];','if(_200.lap=="','llap"){box.x=-box.w;}else{',201,'rlap"){_202[1]=',7,'.Space(-',161,201,'ulap"){box.y=box.d;',164,'0;}else{',201,'dlap"){box.y=-box.h;',164,'0;}}}}_200.nuc',111,'SetList(','_202,_1fe',153,201,'ulap"||_200.lap=="dlap"){_200.nuc.h=_200.nuc.d=0;}_200.type="box";delete _200.atom;},bin',5,'_203,size,_205',',prev){if(prev','&&prev.type){var type=prev.type;if(type=="bin"||type=="op"||type=="rel"||type=="open"||type=="punct"||type==""||(',69,'"&&prev.left!="")){_205.type="ord";}}else{_205',65,'jsMath.mList.prototype.Atomize.SupSub(',223,');},rel',5,'_208,size,_20a',224,'.type&&prev',63,'prev',65,229,233,');},close',5,'_20c,size,_20e',224,'.type&&prev',63,'prev',65,229,243,');},punct',5,'_210,size,_212',224,'.type&&prev',63,'prev',65,229,253,');},open',5,'_214,size,_216','){',229,263,');},inner',5,'_217,size,_219','){',229,269,');},','vcenter',5,'_21a,size,_21c','){',147,111,150,'_21c.nuc,_21a',187,'TeX=',93,'TeX(_21a',153,'box.y=','TeX.axis_height','-(box.h-box.d)/2;_21c.nuc=box;_21c',191,229,276,');},','overline',5,'_21f,size,_221','){var TeX=',93,'TeX(_21f',187,'box',111,150,'_221.nuc',',',93,'PrimeStyle','(_21f),',177,'var t=','TeX.default_rule_thickness',';var rule',111,'Rule(box.w,t);rule.x=-rule.w;rule.y','=box.h+3*t;',304,111,'SetList([box,','rule],_21f',153,304,'.h+=t;_221',191,229,296,');},','underline',5,'_226,size,_228','){var TeX=',93,'TeX(_226',187,'box',111,150,'_228.nuc',',',93,307,'(_226),',177,310,311,';var rule',111,314,'=-box.d-3*t-t;',337,111,318,'rule],_226',153,337,'.d+=t;_228',191,229,329,');},radical',5,'_22d,size,_22f','){var TeX=',93,'TeX(_22d',187,'Cp=',93,307,'(_22d);',147,111,150,'_22f.nuc,Cp,',177,310,311,';var p=t;if(_22d=="D"||_22d=="D\'"){p=TeX.x_height;}var r=t+p/4;var surd',111,'Delimiter(','box.h+box.d','+r+t,[0,2,112,3,112],_22d,1);if(surd.d>',380,'+r){r=(r+surd.d-box.h-box.d)/2;}surd.y=box.h+r;var rule',111,'Rule(box.w,t);rule.y=surd.y-t/2;rule.h+=3*t/2;box.x=-box.w;var Cr=',93,'UpStyle(',93,387,'_22d));var root',111,150,'_22f.root||null,Cr,',177,'if(_22f.root){root.y=0.55*(',380,'+3*t+r)-box.d;surd.x',87,'root.w-(11/18)*surd.w,0);rule.x=(7/18)*surd.w;root.x=-(root.w+rule.x);}_22f.nuc',111,'SetList([','surd,root,rule,box],_22d',153,'_22f',191,229,361,');},accent',5,'_23a,size',',_23c){var TeX=',93,'TeX(_23a',187,'Cp=',93,307,'(_23a);',147,111,150,'_23c.nuc',',Cp',187,'u=box.w;var s;var Font;if(_23c.','nuc.type=="TeX','"){Font',91,'[',422,'.font];if(','Font[_23c.nuc.c].krn','&&Font.skewchar){s=',432,'[Font.skewchar];}}if(s==null){s=0;}var c=_23c.accent[2];var font',91,'.fam[_23c.accent[1]];Font',91,'[font];while(Font[c].n&&Font[Font[c].n].w<=u){c=Font[c].n;}var _245=Math.min(box.h,TeX.','x_height);','if(_23c.',426,'"){var _246=',7,'.Atom("ord",',422,');_246.sup=_23c.sup;_246.sub=_23c.sub;_246.delta=0;',229,410,',_246);_245+=(_246.nuc.h-box.h);box=',422,'=_246.nuc;delete _23c.sup;delete _23c.sub;}var acc',111,'TeX(c,font,',410,');acc.y=box.h-_245;acc.x=-box.w+s+(u-acc.w)/2;if(Font[c].ic){acc.x-=Font[c].ic*TeX.scale;}',422,111,318,'acc],',410,');if(',422,'.w!=box.w){var _248=',7,'.Space(','box.w-',422,'.w);',422,111,401,422,',_248],',410,');}_23c',191,229,410,',_23c);},op',5,'_249,size,_24b','){var TeX=',93,'TeX(_249',187,'box;','_24b.delta','=0;var isD=(_249','.charAt(0)=="','D");if','(_24b.limits','==null&&isD){_24b.limits=1;}if(_24b.',426,'"){var C',91,'[_24b.nuc.font][','_24b.nuc','.c];if(isD&&C.n){',498,'.c=C.n;C',91,497,'C.n];}box',111,'Set(_24b.nuc,_249,size',');if(C.ic){_24b','.delta=C.ic*TeX.scale;if',492,'||!_24b.sub||','jsMath.Browser.msieIntegralBug',1,111,318,7,466,488,')],','_249,size);}}','box.y=-((',380,')/2-box.d-',288,');if(Math.abs(box.y)<0.0001',1,'.y=0;}}if(!box',1,111,506,').Remeasured();}if',492,'){var W=box.w;var x=box.w;var _252=[box];var dh=0;var dd=0;if(_24b.sup){var sup',111,150,'_24b.sup,',93,387,'_249),',177,'sup.x=((box.w-sup.w)/2+',488,'/2)-x;dh=TeX.big_op_spacing5;W',87,'W,sup.w);x+=sup.x+sup.w;sup.y=box.h+sup.d+box.y+Math.max(TeX.big_op_spacing1,TeX.big_op_spacing3-sup.d);','_252[_252.length]=','sup;delete _24b.sup;}if(_24b.sub){var sub',111,150,'_24b.sub,',93,'DownStyle','(_249),',177,'sub.x=((box.w-sub.w)/2-',488,'/2)-x;dd=TeX.big_op_spacing5;W',87,'W,sub.w);x+=sub.x+sub.w;sub.y=-box.d-sub.h+box.y-Math.max(TeX.big_op_spacing2,TeX.big_op_spacing4-sub.h);',545,'sub;delete _24b.sub;}if(W>box.w',1,'.x=(W-box.w)/2;x+=box.x;}if(x<W){',545,7,466,'W-x);}',498,111,217,'_252,_249',153,498,'.h+=dh;',498,'.d+=dd;}',54,511,'&&_24b.sub&&C&&C.ic){',498,111,318,'jsMath.Box.','Space(-C.ic*TeX.scale)],_249,size);}',54,'box.y){',498,111,401,'box],',519,229,482,');}},ord',5,'_257,size,_259',',prev,_25b,i){if(_259.',426,'"&&!_259.sup&&!_259.sub){var _25d=','_25b.mlist[','i+1];if(_25d&&_25d.atom&&_25d.type&&(_25d.type=="ord','"||_25d.type=="','op',601,'bin',601,'rel',601,'open',601,'close',601,'punct")){if(_25d.',426,'"&&_25d.nuc.font==_259.nuc.font){_259.textsymbol=1;var krn',91,'[_259.nuc.font][_259.nuc.c].krn;krn*=',93,'TeX(_257,size).scale;if(krn&&','krn[_25d.nuc.c',']){for(var k=_25b.mlist.length-1;k>i;k--){',599,'k+1]=',599,'k];}',599,'i+1]=',7,466,619,']);}}}}',229,595,');},fraction',5,'_260,size,_262','){var TeX=',93,'TeX(_260',187,'t=0;if(_262.thickness!=null){t=_262.thickness;}',54,'_262.from.match(/over/)){t=',311,';}}var isD=(_260',490,'D");var Cn=(_260=="D")?"T":(_260=="D\'")?"T\'":',93,387,'_260);var Cd=(isD)?"T\'":',93,551,'(_260);var num',111,150,'_262.num,Cn,',177,'var den',111,150,'_262.den,Cd,',177,'var u;var v;var w;var H=(isD)?TeX.delim1:TeX.delim2;var _26e=[',582,112,'_262.left,_260)];var _26f',111,112,'_262.right,_260);if(num.w<den.w){num.x=(den.w-num.w)/2;den.x=-(num.w+num.x);w=den.w;_26e[1]=num;_26e[2]=den;}else{den.x=(num.w-den.w)/2;num.x=-(den.w+den.x);w=num.w;_26e[1]=den;_26e[2]=num;}if(isD){u=TeX.num1;v=TeX.denom1;}else{u=(t!=0)?TeX.num2:TeX.num3;v=TeX.denom2;}if(t==0){var p=(isD)?7*',311,':3*',311,';var r=(u-num.d)-(','den.h-v);if(r<p){','u+=(p-r)/2;v+=(p-r)/2;}}else{var p=(isD)?3*t:t',92,288,672,'a+t/2);if(r<p){u+=p-r;}r=(a-t/2)-(',673,'v+=p-r;}var rule',111,'Rule(w,t);rule.x=-w;rule.y=a-t/2',';_26e[_26e.length]=','rule;}num.y=u;den.y=-v',683,'_26f;_262.nuc',111,217,'_26e,_260',153,'_262',191,'_262',119,'_262.num;delete _262.den;',229,635,');},SupSub',5,'_276,size,_278){var TeX=',93,'TeX(_276',187,'nuc=','_278.nuc',';',147,'=',705,111,150,705,',_276,size,0);if(box.format=="null"){box=',705,111,'Text("","normal",','_276,size);}','if(',426,'"){if(!_278.textsymbol){var C',91,'[nuc.font][nuc.c];if(C.ic){_278',508,'(!_278.sub',1,'=',705,111,318,582,'Space(','_278.delta',')],_276',153,732,'=0;}}}else{',732,'=0;}}if(!_278.sup&&!_278.sub){return;}',705,'.Styled();var Cd=',93,551,'(_276);var Cu=',93,387,'_276);var q=',93,'TeX(Cu,size).','sup_drop;var r=',93,'TeX(Cd,size).','sub_drop;var u=0;var v=0;var p;if(nuc.type&&nuc.type!="text"&&nuc.type!="TeX"&&nuc.type!="null"){u=box.h-q;v=box.d+r;}if(_278.sub){var sub',111,150,'_278.sub,Cd',153,'sub',111,401,'sub,',7,'.Space(TeX.scriptspace)],_276,size',');}if(!_278.sup){sub.y=-Math.max(v,TeX.sub1,sub.h-(4/5)*',93,751,440,705,111,318,'sub],_276,size).Styled();','delete _278.','sub;return;}var sup',111,150,'_278.sup,Cu',153,'sup',111,401,'sup,',7,762,');if(_276=="D"){p=TeX.sup1;}',54,'_276','.charAt(','_276','.length-1)=="\'"){','p=TeX.sup3;}else{p=TeX.sup2;}}u',87,'u,p,sup.d+',93,748,'x_height/4);if(!_278.sub){sup.y=u;',705,111,318,'sup],_276',153,771,'sup;return;}v',87,'v,',93,751,'sub2);',310,311,';if((u-sup.d)-(sub.h-v)<4*t){v=4*t+sub.h-(u-sup.d);p=(4/5)*TeX.x_height-(u-sup.d);if(p>0){u+=p;v-=p;}}sup',156,'sub',156,'sup.y=u;sub.y=-v;sup.x=',732,';if(sup.w+sup.x>sub.w){sup.x-=sub.w;',705,111,318,'sub,sup],',717,'else{sub.x-=(sup.w+sup.x);',705,111,318,'sup,sub],',717,771,'sup;',771,'sub',';}});jsMath.',125,'=function(_287){this.type="typeset";',11,'=_287;};',139,125,',{upStyle:{D:"S",T:"S","','D\'":"S\'","T\'":"S\'",S:"SS','",SS:"SS","','S\'":"SS\'","SS\'":"SS\'"},','downStyle:{D:"S\'",T:"S\'","',839,'\'",SS:"SS\'","',841,'UpStyle',5,'_288){',3,'this.upStyle[_288];},',551,5,'_289){',3,'this.downStyle[_289];},',307,5,'_28a){if(_28a',786,'_28a',788,3,'_28a;}',3,'_28a+"\'";},StyleValue',5,'_28b,v){if(_28b=="S"||_28b=="S\'"){',3,'0.7*v;}if(_28b=="SS"||_28b=="SS\'"){',3,'0.5*v;}',3,'v;},StyleSize',5,'_28d,size){if(_28d=="S"||_28d=="S','\'"){size=Math.max(0,size-','2);}else{if(','_28d=="SS','"||',878,876,'4);}}',3,'size;},TeX',5,'_28f,size){if(_28f=="S"||_28f=="S',876,877,'_28f=="SS','"||',889,876,882,3,'jsMath.TeXparams[size];},AddStyle',5,'_291,size,html){if(_291=="S"||_291=="S',876,877,'_291=="SS','"||',900,876,882,'if(size!=4){html="<span class=\\"size"+size+"\\">"+','html+"</span>";}',3,'html;},AddClass',5,'_294,html){if(_294!=""&&_294!="normal"){html=',159,'Class(_294,html);}',3,'html;}});','jsMath.Package(jsMath.',125,',{DTsep:{ord',':{op:1,bin:2,rel:3,inner:1},','op',':{ord:1,op:1',',rel:3,inner:1},bin:{ord:2,op:2,open:2,inner:2},rel:{ord:3,op:3,open:3,inner:3},open:{},close',918,'punct',920,',rel:1,open:1,close',':1,punct:1,inner:1','},inner',920,',bin:2,rel:3,open',926,'}},SSsep:{ord:{op:1},op',920,'},bin:{},rel:{},open:{},close:{op:1},punct:{},inner:{op:1}},sepW:["","thinmuskip","medmuskip","thickmuskip"],','GetSeparation',5,'l,r,_298){if(l&&l.atom&&r.atom){var _299=this.DTsep;if(_298',490,'S"){_299=this.SSsep;}var row=_299[l.type];if(row&&row[r.type]!=null){',3,'jsMath.TeX[this.sepW[row[r.type]]];}}',3,'0;},',125,5,'_29b,size){',39,'=_29b;',41,'=size;var _29d=-10000;this.w=0;this.h=_29d;this.d=_29d;this.bh=this.h;this.bd=this.d;this.tbuf="";this.tx=0;','this.tclass','="";','this.cbuf','="";this.hbuf="";this.hx=0;var _29e=null;var prev;this.x=0;this.dx=0;for(var i=0;i<',11,44,'prev=_29e;_29e=',11,'[i];switch(_29e.type){case "size":','this.FlushClassed();',41,'=_29e.size;','_29e=prev;break;case "','style":',959,'if(',39,786,39,788,39,'=_29e.style','+"\'";}else{',39,971,';}',962,'space":if(typeof (_29e.w)=="object"){if(',39,786,'1)=="','S"){_29e.w=0.','5*','_29e.w[0]/18',';}',54,39,490,981,'7*',983,';}else{_29e.w=',983,';}}}this.dx+=_29e.w-0;',962,'html":',959,'if(this.hbuf==""){this.hx=this.','x;}','this.hbuf+=','_29e.html;_29e=prev;break;default:if(!_29e.atom&&_29e.type!="box"){break;}','_29e.nuc.','x+=this.dx+this.',934,'(prev,_29e,',39,');if(',1001,'y||',1001,'x){',1001,'Styled();}this.dx=0;this.x=this.x+this.w;this.w+=',1001,'w+',1001,'x;if(',1001,'format=="text"){if(',950,'!=',1001,'tclass&&',950,'!=""){','this.FlushText','();}','if(this.tbuf','==""&&',952,'==""){this.tx=this.x;}this.tbuf+=',1001,'html;',950,'=',1001,'tclass;}else{',959,'if(',1001,'x||',1001,'y){this.Place(_29e.nuc);}',997,'x;}',999,1001,'html;}this.h',87,'this.h,',1001,'h+',1001,'y);this.bh',87,'this.bh,',1001,'bh);this.d',87,'this.d,',1001,'d-',1001,'y);this.bd',87,'this.bd,',1001,'bd);break;}}',959,'if(this.dx){',999,159,160,'this.dx);this.w+=this.dx;}if(this.hbuf==""){',3,582,'Null;}if(this.h==_29d){this.h=0;}if(this.d==_29d){this.d=0;}',147,15,'Box("html",this.hbuf,this.w,this.h,this.d);box.bh=this.bh;box.bd=this.bd;',3,'box;},FlushText',29,1027,'==""){return;}',952,'+=',93,'AddClass(',950,',this.tbuf);this.tbuf="";',950,'="";},FlushClassed',29,1025,'();if(',952,1084,997,'tx;}',999,93,'AddStyle(',39,',',41,',',952,');',952,'="";},Place',5,'item){var ','html="<span style=\\"position: relative',';";if(item.x){html+=" margin-left:"+',159,'Em(item.x)+";";}if(item.y){html+=" top:"+',159,'Em(-item.y',')+";";}item.html=html+"\\">"+item.html+"</span>";','item.h+=item.y;item.d-=item.y;item.x=0;item.y=0',';},PlaceSeparateSkips',5,'item){if(item.y){item.',1113,'; "+"top:"+',159,1118,')+";"+"\\">"+item.',906,'if(item.x){item.html=',159,160,'item.x)+item.html;}',1120,831,'Parse','=function(s,font,size,','_2a8){var _2a9',15,'Parser(s,font,size,_2a8);_2a9.Parse();',3,'_2a9;};jsMath.Parser',1137,'_2ad){this.string=s;this.i=0;',11,15,'mList(null,font,size,_2ad);};',915,'Parser,{cmd:"\\\\",open:"{",close:"}",letter:/[a-z]/i,number:/[0-9]/,scriptargs:/^((math|text)..|mathcal|[hm]box)$/,mathchar:{"!":[5,0,33],"(":[4,0,40],")":[5,0,41],"*":[2,2,3],"+":[2,0,43],",":[6,1,59],"-":[2,2,0],".":[0,1,58],"/":[0,1,61],":":[3,0,58],";":[6,0,59],"<":[3,1,60],"=":[3,0,61],">":[3,1,62],"?":[5,0,63],"[":[4,0,91],"]":[5,0,93],"|":[0,2,106]},special:{"~":"Tilde","^":"HandleSuperscript","_":"HandleSubscript"," ":"Space","\\x01','":"Space","\\','t',1150,'r',1150,'n":"Space","\'":"Prime","%":"HandleComment","&":"HandleEntry"},mathchardef:{braceld:[0,3,122],bracerd:[0,3,123],bracelu:[0,3,124],braceru:[0,3,125],alpha:[0,1,11],beta:[0,1,12],gamma:[0,1,13],delta:[0,1,14],epsilon:[0,1,15],zeta:[0,1,16],eta:[0,1,17],theta:[0,1,18],iota:[0,1,19],kappa:[0,1,20],lambda:[0,1,21],mu:[0,1,22],nu:[0,1,23],xi:[0,1,24],pi:[0,1,25],rho:[0,1,26],sigma:[0,1,27],tau:[0,1,28],upsilon:[0,1,29],phi:[0,1,30],chi:[0,1,31],psi:[0,1,32],omega:[0,1,33],varepsilon:[0,1,34],vartheta:[0,1,35],varpi:[0,1,36],varrho:[0,1,37],varsigma:[0,1,38],varphi:[0,1,39],Gamma:[7,0,0],Delta:[7,0,1],Theta:[7,0,2],Lambda:[7,0,3],Xi:[7,0,4],Pi:[7,0,5],Sigma:[7,0,6],Upsilon:[7,0,7],Phi:[7,0,8],Psi:[7,0,9],Omega:[7,0,10],aleph:[0,2,64],imath:[0,1,123],jmath:[0,1,124],ell:[0,1,96],wp:[0,1,125],Re:[0,2,60],Im:[0,2,61],partial:[0,1,64],infty:[0,2,49],prime:[0,2,48],emptyset:[0,2,59],nabla:[0,2,114],surd:[1,2,112],top:[0,2,62],bot:[0,2,63],triangle:[0,2,52],forall:[0,2,56],exists:[0,2,57],neg:[0,2,58],lnot:[0,2,58],flat:[0,1,91],natural:[0,1,92],sharp:[0,1,93],clubsuit:[0,2,124],diamondsuit:[0,2,125],heartsuit:[0,2,126],spadesuit:[0,2,127],coprod:[1,3,96],bigvee:[1,3,87],bigwedge:[1,3,86],biguplus:[1,3,85],bigcap:[1,3,84],bigcup:[1,3,83],intop:[1,3,82],prod:[1,3,81],sum:[1,3,80],bigotimes:[1,3,78],bigoplus:[1,3,76],bigodot:[1,3,74],ointop:[1,3,72],bigsqcup:[1,3,70],smallint:[1,2,115],triangleleft:[2,1,47],','triangleright',':[2,1,46],bigtriangleup:[2,2,52],bigtriangledown:[2,2,53],wedge:[2,2,94],land:[2,2,94],vee:[2,2,95],lor:[2,2,95],cap:[2,2,92],cup:[2,2,91],ddagger:[2,2,122],dagger:[2,2,121],sqcap:[2,2,117],sqcup:[2,2,116],uplus:[2,2,93],amalg:[2,2,113],diamond:[2,2,5],bullet:[2,2,15],wr:[2,2,111],div:[2,2,4],odot:[2,2,12],oslash:[2,2,11],otimes:[2,2,10],ominus:[2,2,9],oplus:[2,2,8],mp:[2,2,7],pm:[2,2,6],circ:[2,2,14],bigcirc:[2,2,13],setminus:[2,2,110],cdot:[2,2,1],ast:[2,2,3],times:[2,2,2],star:[2,1,63],propto:[3,2,47],sqsubseteq:[3,2,118],sqsupseteq:[3,2,119],parallel:[3,2,107],mid:[3,2,106],dashv:[3,2,97],vdash:[3,2,96],leq:[3,2,20],le:[3,2,20],geq:[3,2,21],ge:[3,2,21],succ:[3,2,31],prec:[3,2,30],approx:[3,2,25],succeq:[3,2,23],preceq:[3,2,22],supset:[3,2,27],subset:[3,2,26],supseteq:[3,2,19],subseteq:[3,2,18],"in":[3,2,50],ni:[3,2,51],owns:[3,2,51],gg:[3,2,29],ll:[3,2,28],not:[3,2,54],sim:[3,2,24],simeq:[3,2,39],perp:[3,2,63],equiv:[3,2,17],asymp:[3,2,16],smile:[3,1,94],frown:[3,1,95],Leftrightarrow:[3,2,44],Leftarrow:[3,2,40],Rightarrow:[3,2,41],leftrightarrow:[3,2,36],leftarrow:[3,2,32],gets:[3,2,32],rightarrow:[3,2,33],to:[3,2,33],mapstochar:[3,2,55],leftharpoonup:[3,1,40],','leftharpoondown',':[3,1,41],rightharpoonup:[3,1,42],rightharpoondown:[3,1,43],nearrow:[3,2,37],searrow:[3,2,38],nwarrow:[3,2,45],swarrow:[3,2,46],hbarchar:[0,0,22],lhook:[3,1,44],rhook:[3,1,45],ldotp:[6,1,58],cdotp:[6,2,1],colon:[6,0,58],"#":[7,0,35],"$":[7,0,36],"%":[7,0,37],"&":[7,0,38]},delimiter:{"(":[0,0,40,3,0],")":[0,0,41,3,1],"[":[0,0,91,3,2],"]":[0,0,93,3,3],"<":[0,2,104,3,10],">":[0,2,105,3,11],"/":[0,0,47,3,14],"|":[0,2,106,3,12],".":[0,0,0,0,0],"\\\\":[','0,2,110,3,15],"\\\\','lmoustache":[4,3,122,3,64],"\\\\rmoustache":[5,3,123,3,65],"\\\\lgroup":[4,6,40,3,58],"\\\\rgroup":[5,6,41,3,59],"\\\\arrowvert','":[0,2,106,3,','60],"\\\\Arrowvert":[0,2,107,3,61],"\\\\bracevert',1162,'62],"\\\\Vert":[0,2,107,3,13],"\\\\|":[0,2,107,3,13],"\\\\vert',1162,'12],"\\\\uparrow":[3,2,34,3,120],"\\\\downarrow":[3,2,35,3,121],"\\\\updownarrow":[3,2,108,3,63],"\\\\Uparrow":[3,2,42,3,126],"\\\\Downarrow":[3,2,43,3,127],"\\\\Updownarrow":[3,2,109,3,119],"\\\\backslash":[',1160,'rangle":[5,2,105,3,11],"\\\\langle":[4,2,104,3,10],"\\\\rbrace":[5,2,103,3,9],"\\\\lbrace":[4,2,102,3,8],"\\\\}":[5,2,103,3,9],"\\\\{":[4,2,102,3,8],"\\\\rceil":[5,2,101,3,7],"\\\\lceil":[4,2,100,3,6],"\\\\rfloor":[5,2,99,3,5],"\\\\lfloor":[4,2,98,3,4],"\\\\lbrack":[0,0,91,3,2],"\\\\rbrack":[0,0,93,3,3]},macros:{displaystyle',':["HandleStyle","','D"],textstyle',1170,'T"],scriptstyle',1170,'S"],scriptscriptstyle',1170,'SS"],rm',':["HandleFont",','0],mit',1178,'1],oldstyle',1178,'1],cal',1178,'2],it',1178,'4],bf',1178,'6],font',':["Extension","','font"],left:"HandleLeft",right:"HandleRight",arcsin',':["NamedOp",0],','arccos',1192,'arctan',1192,'arg',1192,'cos',1192,'cosh',1192,'cot',1192,'coth',1192,'csc',1192,'deg',1192,'det',':"NamedOp",','dim',1192,'exp',1192,'gcd',1212,'hom',1192,'inf',1212,'ker',1192,'lg',1192,'lim',1212,'liminf',':["NamedOp",null,"lim<span style=\\"margin-left: "+1/6+"em\\"></span>','inf"],limsup',1230,'sup"],ln',1192,'log',1192,'max',1212,'min',1212,'Pr',1212,'sec',1192,'sin',1192,'sinh',1192,'sup',1212,'tan',1192,'tanh',1192,274,':["HandleAtom","',274,'"],',294,1256,294,'"],',327,1256,327,'"],over',':"HandleOver",','overwithdelims',1267,'atop',1267,'atopwithdelims',1267,'above',1267,'abovewithdelims',1267,'brace',':["HandleOver','","\\\\{","\\\\}"],brack',1279,'","[","]"],choose',1279,'","(",")"],overbrace',1190,'leaders"],','underbrace',1190,1286,'overrightarrow',1190,1286,'overleftarrow',1190,1286,'overset',1190,'underset-overset"],','underset',1190,1298,'llap',':"HandleLap",','rlap',1303,'ulap',1303,'dlap',1303,'raise:"RaiseLower",lower:"RaiseLower",moveleft',':"MoveLeftRight",','moveright',1311,'frac:"Frac",root:"Root",sqrt:"Sqrt",hbar',':["Macro","\\\\','hbarchar\\\\kern-.5em h"],ne',1315,'not="],neq',1315,'not="],notin',1315,'mathrel{\\\\','rlap{\\\\kern2mu/}}\\\\in"],cong',1315,1322,'lower2mu{\\\\','mathrel','{{\\\\rlap{=}\\\\raise6mu\\\\sim}}}}"],bmod',1315,'mathbin{\\\\rm mod}"],pmod',1315,'kern 18mu ({\\\\rm mod}\\\\,\\\\,#1)",1],"int":["Macro","\\\\intop\\\\nolimits"],oint',1315,'ointop\\\\nolimits"],doteq',1315,'buildrel\\\\textstyle.\\\\over="],ldots',1315,'mathinner{\\\\','ldotp\\\\ldotp\\\\ldotp}"],cdots',1315,1338,'cdotp\\\\cdotp\\\\cdotp}"],vdots',1315,1338,'rlap{\\\\raise8pt{.\\\\rule 0pt 6pt 0pt}}\\\\rlap{\\\\raise4pt{.}}.}"],ddots',1315,1338,'kern1mu\\\\raise7pt{\\\\rule 0pt 7pt 0pt .}\\\\kern2mu\\\\raise4pt{.}\\\\kern2mu\\\\raise1pt{.}\\\\kern1mu}"],joinrel',1315,1322,'kern-4mu}"],relbar',1315,1322,'smash-}"],','Relbar',1315,1327,'="],bowtie',1315,1327,'\\\\',1156,'\\\\joinrel\\\\',1327,'\\\\triangleleft"],models',1315,1327,'|\\\\joinrel="],mapsto',1315,'mapstochar\\\\','rightarrow"],rightleftharpoons',1315,274,'{\\\\',1322,'rlap{\\\\raise3mu{\\\\rightharpoonup}}}\\\\',1158,'}"],hookrightarrow',1315,'lhook\\\\','joinrel\\\\rightarrow"],','hookleftarrow',1315,'leftarrow\\\\joinrel\\\\','rhook"],Longrightarrow',1315,1355,1363,'Rightarrow"],','longrightarrow',1315,'relbar\\\\',1381,'longleftarrow',1315,1384,'relbar"],Longleftarrow',1315,'Leftarrow\\\\joinrel\\\\',1355,'"],longmapsto',1315,1370,'char{cmsy10}{0}\\\\',1381,'longleftrightarrow',1315,'leftarrow\\\\',1381,'Longleftrightarrow',1315,1399,1389,'iff:["Macro","\\\\;\\\\',1410,'\\\\;"],mathcal',':["Macro","{\\\\','cal #1}",1],mathrm',1417,'rm #1}",1],mathbf',1417,'bf #1}",1],','mathbb',1417,1422,'mathit',1417,'it #1}",1],textrm',1315,'mathord{\\\\hbox{#1}}",1],','textit',1315,'mathord{\\\\class{',1431,'}{\\\\hbox{#1}}}",1],','textbf',1315,1433,1436,1435,'TeX:["Macro","T\\\\kern-.1667em\\\\lower.5ex{E}\\\\kern-.125em X"],limits:["Limits",1],nolimits:["Limits",0],",":["Spacer",1/6],":":["Spacer",1/6],">":["Spacer",2/9],";":["Spacer",5/18],"!":["Spacer",-1/6],enspace:["Spacer",1/2],quad:["Spacer",1],qquad:["Spacer",2],thinspace:["Spacer",1/6],negthinspace:["Spacer",-1/6],hskip:"Hskip",kern:"Hskip",rule:["Rule","colored"],space:["Rule","blank"],big',':["MakeBig","','ord",0.85],Big',1442,'ord",1.15],bigg',1442,'ord",1.45],Bigg',1442,'ord",1.75],bigl',1442,'open",0.85],Bigl',1442,'open",1.','15],biggl',1442,1453,'45],Biggl',1442,1453,'75],bigr',1442,'close",0.85],Bigr',1442,'close",1.','15],biggr',1442,1464,'45],Biggr',1442,1464,'75],bigm',1442,'rel",0.85],Bigm',1442,'rel",1.15],biggm',1442,'rel",1.45],Biggm',1442,'rel",1.75],mathord',1256,'ord"],mathop',1256,'op"],mathopen',1256,'open"],mathclose',1256,'close"],mathbin',1256,'bin"],',1327,1256,'rel"],mathpunct',1256,'punct"],mathinner',1256,'inner"],','mathchoice',1190,1497,'"],buildrel:"BuildRel",hbox:"HBox",text:"HBox",mbox:"HBox",fbox',1190,'fbox"],strut:"Strut",mathstrut',1315,'vphantom{(}"],phantom:["Phantom",1,1],vphantom:["Phantom",1,0],hphantom:["Phantom",0,1],smash:"Smash",acute',':["MathAccent",[7,0,','19]],grave',1505,'18]],ddot',1505,'127]],tilde',1505,'126]],bar',1505,'22]],breve',1505,'21]],check',1505,'20]],hat',1505,'94]],vec',':["MathAccent",[0,','1,126]],dot',1505,'95]],widetilde',1521,'3,101]],widehat',1521,'3,98]],"_":["','Replace","ord','","_","normal",-0.4,0.1]," ":["',1529,'","&nbsp;","normal"],angle:["',1529,'","&#x2220;","normal"],matrix:"Matrix",array:"Matrix",pmatrix:["Matrix","(",")","c"],cases:["Matrix","\\\\{",".",["l","l"],null,2],eqalign',':["Matrix",null,null,["','r","l"],[5/18],3,"D"],displaylines',1535,'c"],null,3,"D"],cr:"HandleRow","\\\\":"HandleRow",noalign:"HandleNoAlign",eqalignno',1535,'r","l","r"],[5/8,3],3,"D"],','leqalignno',1535,1540,'begin:"Begin",end:"End",tiny',':["HandleSize",','0],Tiny',1545,'1],scriptsize',1545,'2],small',1545,'3],normalsize',1545,'4],large',1545,'5],Large',1545,'6],LARGE:["HandleSize'],
  ['",7],huge:["','HandleSize','",8],Huge:["',1,'",9],dots:["','Macro','","\\\\ldots"],','newcommand',':["Extension","',7,'"],def',8,7,'"],color',8,'HTML"],','href',8,'HTML"],"class":["','Extension','","',15,'style',8,15,'cssId',8,15,'unicode',8,15,'bbox',8,31,'"],require:"','Require','","char":"Char"},','environments',':{array:"Array",','matrix',':["Array",null,null,"','c"],pmatrix:["Array","(",")","c"],bmatrix:["Array","[","]","c"],Bmatrix:["Array","\\\\{","\\\\}","c"],vmatrix:["Array","\\\\vert","\\\\vert","c"],Vmatrix:["Array","\\\\Vert","\\\\Vert","c"],cases:["Array","\\\\{",".","ll",null,2],eqnarray',40,'rcl",[5/18,5/18],3,"D"]},AddSpecial',':function','(obj){','for(var id in obj){','jsMath.Parser.prototype','.special[',47,'[id]]=obj[id];}},Error',44,'(s){','this.i','=this.','string.length;if(s','.error){','this.error','=s.error;}else{if(!this',56,57,'=s;}}},nextIsSpace',44,'(){','return ','this.string.charAt(this.i',')==" ";},trimSpaces',44,'(text){','if(typeof (','text)!="string"){',64,'text;}',64,'text','.replace(/^\\s+|\\s','+/g,"");},','Process',44,'(arg','){var ','data=','this.mlist.','data;','arg=','jsMath.','Parse(arg,','data.font',',','data.size',',data.style',');if(arg',56,'this.Error(','arg);','return null;}','if(arg.mlist.Length()==','0){',95,96,'1',80,'atom=','arg.mlist.','Last();if','(atom','.atom&&','atom.type=="ord"&&atom.nuc&&!atom.sub&&!atom.sup&&(','atom.nuc.type=="','text"||',108,'TeX")){',64,'atom.nuc;}}return {type:"mlist",mlist:arg.mlist};},','GetCommand',44,'(){var ','_2b5=/^([a-z]+|.) ?/i;var cmd=_2b5.exec(','this.string.slice(','this.i));','if(','cmd){','this.i+=','cmd[1].length;',64,'cmd[1];}','this.i++;','return " ";},','GetArgument',':function(name',',','_2b8){','while','(this.nextIsSpace()){this.i','++;}if(',53,'>=','this.string','.length){','if(!',131,'this.Error("','Missing',' argument for "+name);}',95,'if(',65,')==this.','close){if(!',131,141,'Extra close brace','");}',95,'if(',65,147,121,126,64,'this.cmd+','this.',114,'();}if(',65,')!=this.open','){return ',65,'++);}var j','=++this.i;var ','_2ba=1;var c="";',132,'(this.i<this.string.length){','c=',65,'++);','if(c==this.cmd){',53,'++;}else{if(c','==this.open){_2ba',178,'==this.close){if(_2ba==0){',141,151,'");',95,'if(--_2ba==0',166,118,'j,',53,'-1);}}}}}',141,'Missing close brace','");return',' null;},ProcessArg',129,'){var arg=this.',128,'(','name);','if(this.error){return',' null;}','return this.Process(arg);},','ProcessScriptArg',129,197,128,'(',200,201,202,'if(arg.charAt(0',147,'cmd',80,'_2c0=arg.substr(1);if(_2c0=="frac"){arg+="{"+this.',128,'(_2c0)+"}";',201,202,'arg+="{"+this.',128,'(_2c0)+"}";',201,' null;}}else{if(_2c0','=="sqrt"){arg+="["+this.','GetBrackets','(_2c0)+"]";',201,202,'arg+="{"+this.',128,'(_2c0)+"}";',201,225,'.match(this.scriptargs)){arg+="{"+this.',128,'(_2c0)+"}";',201,' null;}}}}}',203,'GetDelimiter',129,'){',132,133,'++;}var ','c=',65,');if',172,126,176,'c="\\\\"+this.',114,'(',200,201,' null;}}','if(','this.delimiter[','c]!=null',166,261,'c];}}',141,142,' or unrecognized delimiter for "+','name);return null;},','GetDimen',129,',nomu',80,'rest;var _2c6=0;if',133,'++;}if(',65,')=="{"){rest',54,128,'(name);}else{rest=',118,53,');_2c6=1;}',64,'this.','ParseDimen','(rest,name,_2c6,nomu);},',287,44,'(_2c7,name,_2c9,nomu',80,'_2cb=_2c7.match(/^\\s*([-+]?(\\.\\d+|\\d+(\\.\\d*)?))(pt|em|ex|mu|px)/);if(!_2cb){',141,142,' dimension or its units for "+',200,95,'if(_2c9){',122,'_2cb[0].length;if',133,'++;}}var d=_2cb[1]-0;if(_2cb[4]=="px"){d/=',85,'em',';}else{if(_2cb[4]=="','pt"){d/=10',306,'ex"){d*=','jsMath.TeX.','x_height',306,'mu"){if(nomu){d=d/18;}else{d=[d,"mu"];}}}}}',64,'d;},GetNext',44,'(){',132,133,'++;}',64,65,');},',227,129,80,'c',54,'GetNext();if(c','!="["){return "";}var _2cf',169,'_2d0=0;',132,172,'var c=',65,'++);if(c=="{"){','_2d0',178,'=="}"){if(','_2d0==0){',141,151,' while looking for',' \']\'");',95,'_2d0--;}else{',176,53,178,'=="]"){if(_2d0==0',166,118,'_2cf,',53,'-1);}}}}}}',141,'Couldn\'t find',' closing \']\' for argument to "+',160,269,'GetUpto',129,',_2d3){',132,133,247,'_2d4',54,'i;var _2d5=0;',132,172,'var c=',65,337,'_2d5',178,340,'_2d5==0){',141,151,344,' "+',160,'_2d3);',95,'_2d5--;}else{',176,'if(',118,'this.i,this.i+','5)=="begin"){_2d5++;',122,'4;}else{if(',118,391,'3)=="end"){if(_2d5>0){_2d5--;',122,'2;}}}if(',379,'if(',118,391,'_2d3.length',')==_2d3){c=',65,'+',404,');if(c.match(/[^a-z]/i)||!_2d3.match(/[a-z]/i)){var arg=',118,'_2d4,',53,'-1);',122,404,';',64,'arg;}}}',53,'++;}}}}',141,358,' "+',160,'_2d3+" for "+',269,'ProcessUpto',129,',_2d9',197,362,'(name,_2d9);',201,202,203,'GetEnd',44,'(env',80,'body="";var name="";',132,'(name!=env){body+=this.',362,'("begin{"+env+"}","end");',201,202,'name',54,128,'(this.cmd+"','end");',201,259,64,'body;},Space',44,'(){},','Prime',44,'(c',80,'base=',82,104,'(base==null||(!base',106,'base.type!="','box"&&',467,'frac")){',462,'this.mlist.Add(jsMath.mItem.','Atom("ord",{type:null}));}','if(base.sup){',141,'Prime causes double exponent',': use braces to clarify");return',';}var ','sup="";',132,'(c=="\'"){sup+=this.cmd+"prime";c',54,329,'=="\'"){',53,'++;}}base.sup',54,77,'(sup);','base.sup.isPrime','=1;},RaiseLower',129,80,'h','=this.GetDimen(this.cmd+name',',1);',201,478,'box',54,204,'(this.cmd+name);if(this.error){return',';}if(name=="','lower"){h=-h;}',82,'Add(new jsMath.mItem("','raise",{nuc:box,raise:h}));},MoveLeftRight',129,80,'x',495,496,201,478,'box','=this.ProcessArg',502,503,'moveleft"){x=-x;}',472,'Space(x));',472,'Atom("ord",box));',472,'Space(-x));},',35,129,80,'file',54,128,502,';}file=',85,19,'.URL(file);if(','jsMath.Setup.','loaded[file',']){','return;}','this.',19,'(null,[','file]);},',19,129,',data){','jsMath.Translate','.restart=1;if(name','!=null){','delete ',47,'[data[1]||"macros"][name];}',85,19,'.',35,'(data[0],',548,'.asynchronous',');throw "restart";},Frac',129,80,'num',516,502,478,'den',516,502,';}',472,'Fraction("over",num,den));},Sqrt',129,80,'n',54,227,502,478,'arg',516,502,';}var box=jsMath.mItem.Atom("radical",arg);','if(n!=""){box.root',54,77,'(n);',201,';}}',82,'Add(box);},','Root',129,80,'n',54,427,'(',160,'name,"of");',201,478,'arg',516,502,584,'box.root=n;',82,592,'BuildRel',129,80,'top',54,427,'(',160,'name,"over");',201,478,'bot',516,502,478,'op=',85,'mItem.Atom("','op",bot);op.limits=1;op.sup=top;',82,'Add(op);},MakeBig',129,',data){var ','type=data[0];var h=data[1]*',85,'p_height;var _2fe',54,242,502,';}',472,'Atom(type,',85,'Box.Delimiter(h,_2fe,"T")));},Char',129,80,'font',54,128,502,478,'n',54,128,502,';}if(!','jsMath.TeX[font',']){',657,']=[];this.',19,543,'jsMath.Font.URL(font',')]);}else{',472,'Typeset(',85,'Box.TeX(n-0,font,"T",',82,89,')));}},Matrix',129,',_303',80,'data=',82,83,'var arg',54,128,502,478,'_306','=new jsMath.Parser(arg+this.cmd+"\\\\",null,data.size,','_303[5]||"T");_306.',39,'=name;_306.row=[];_306.table=[];_306.rspacing=[];_306.Parse();if(_306',56,93,'_306);',540,'_306','.HandleRow(name,1);var box=jsMath.Box.Layout(data.size,','_306.table,_303[2]||null,_303[3]||null,_306.rspacing,_303[4]||null);if(_303[0]&&_303[1]){var left','=jsMath.Box.Delimiter(box.h+box.d-jsMath.hd/4,this.delimiter[','_303[0]],"T");var _309',695,'_303','[1]],"T");box=jsMath.Box.SetList([left,box,','_309],','data.style,data.size',');}',472,'Atom((_303','[0]?"inner":"ord"),box));},','HandleEntry',129,'){','if(!this.',39,'){',93,'name+" can only appear in a matrix or array");return;}if(',82,'data.openI',550,'var open=',82,'Get(',82,715,');if(open','.left){',141,142,' "+this.cmd+"right','");}else{',141,193,'");}}if(',82,'data.overI',550,82,'Over();}var data=',82,83,82,'Atomize(',701,');var box=',82,666,701,');this.row[','this.row.length',']=box;this.mlist=new ',85,'mList(null,null,',89,90,');},HandleRow',129,',last',80,'_310;',709,39,'){',93,160,713,'name=="\\\\"){_310',54,227,502,';}if(_310){','_310',54,287,'(_310,',160,'name,0,1);}}this.',706,'(',200,'if(!last||',746,'>1||this.row[0].format!="null"){this.table[this.table','.length]=this.','row',767,'this.rspacing[this.table.length',']=_310;}this.row=[];},HandleNoAlign',129,197,128,502,478,'skip=arg.replace(/^.*(vskip|vspace)([^a-z])/i,"$2");if(skip.length==arg',138,'return',478,'d',54,287,'(skip,',160,'RegExp.$1,0',496,201,';}',783,']=(',783,']||0)+d;},Array',129,',_316',80,'_317=_316[2];var _318=_316[3];if(!_317){_317',54,128,450,'begin{"+name+"}");',201,';}}_317=_317.replace(/[^clr]/g,"");_317=_317.split("");var data=',82,83,'var _31a=_316[5]||"T";var arg',54,436,'(',200,201,478,'_31c',684,'_31a);_31c.',39,'=name;_31c.row=[];_31c.table=[];_31c.rspacing=[];_31c.Parse();if(_31c',56,93,'_31c);',540,'_31c',693,'_31c.table,_317,_318,_31c.rspacing,_316[4]);if(_316[0]&&_316[1]){var left',695,'_316[0]],"T");var _31f',695,'_316',699,'_31f],',701,');}',472,'Atom((_316',705,'Begin',129,80,'env',54,128,502,';}if(env.match(/[^a-z*]/i)){',141,'Invalid',' environment',' name',' \\""+env+"\\"");return;}',709,37,'[env]){',141,'Unknown',859,861,'var cmd',54,37,'[env];',69,'cmd',')=="string"){','cmd=[cmd];}this[cmd[0]](env,cmd.slice(1));},End',129,80,'env',54,128,502,';}',93,160,'name+"{"+env+"} without matching "+this.cmd+"begin");},Spacer',129,',w){',472,'Space(w-0));},Hskip',129,80,'w',54,270,502,';}',472,'Space(w));},HBox',129,'){var text=this.',128,502,';}','var box=jsMath.','Box.InternalMath(text,',82,89,');',472,666,'box));},Rule',129,',_32d',80,'w',495,496,201,478,'h',495,496,201,478,'d',495,496,201,';}h+=d;var html;if(h!=0){h=Math.max(1.05/',85,'em,h);}if(h==0||w==0||_32d=="blank"){html=','jsMath.HTML.','Blank(w,h);}else{html=',933,'Rule(w,h);}if(d){html','="<span style=\\"','vertical-align:"+',933,'Em(-d)+"\\">"+','html+"</span','>";}',472,666,'new ',85,'Box("html",html,w,h-d,d)));},Strut',44,116,'size=',82,89,';',905,'Box.Text("","normal","T",size).Styled();box.bh=box.bd=0;box.h=0.8;box.d=0.3;box.w=0;',472,666,'box));},Phantom',129,633,'arg',516,502,';}',82,506,'phantom",{phantom:arg,v:data[0],h:data[1]}));},Smash',129,633,'arg',516,502,';}',82,506,'smash",{smash:arg}));},MathAccent',129,',_33b',80,'c',516,502,478,102,85,628,'accent",c);atom.accent=_33b[0];',82,'Add(atom);},NamedOp',129,633,'a=(name.match(/[^acegm-su-z]/))?1:0;var d=(name.match(/[gjpqy]/))?0.2:0;if(data[1]){name=data[1];}',905,'mItem.TextAtom("op",name,"cmr10",a,d);if(data[0]!=null){box.limits=data[0];}',82,592,'Limits',129,633,102,82,104,'(!atom||atom.type!="op"){',93,160,'name+" is allowed only on operators',194,';}atom.limits=data[0];},',5,129,633,'text=data[0];if(data[1]){var args=[];','for(var i=0;i<','data[1];i++){args[args',780,128,502,';}}text',54,'SubstituteArgs','(args,text);}',137,54,'AddArgs(','text,',118,119,53,'=0;},',1020,44,'(args,_34c',80,'text="";var _34e="";var c;var i','=0;while(i<','_34c',138,'c=','_34c.charAt(i','++);',176,'text+=c+',1039,'++);}else{if(c=="#"){c=',1039,'++);if(','c=="#"){text+=c;}else{if(!c.match(/[1-9]/)||c>args',138,141,'Illegal macro parameter reference");',95,'_34e',54,1024,'this.AddArgs(_34e,text','),args[c-1]);text="";}}else{text+=c;}}}',64,1055,');},AddArgs',44,'(s1,s2){if(s2.match(/^[a-z]/i)&&s1.match(/(^|[^\\\\])(\\\\\\\\)*\\\\[a-z]+$/i)){s1+=" ";}',64,'s1+s2;},Replace',129,547,472,'TextAtom',558,'data[1],data[2],data[3]));},Tilde',129,'){',472,'TextAtom("ord','","&nbsp;","normal"));},HandleLap',129,80,'box',516,'();',201,';}box=',82,506,'lap",{nuc:box,lap:name}));},HandleAtom',129,633,'arg',516,502,';}',472,'Atom(data,arg));},HandleMathCode',129,',code','){this.HandleTeXchar(','code[0],code[1],code[2]);},HandleTeXchar',44,'(type,font,code){if(type==7&&',82,87,550,'font=',82,87,';}font=',310,'fam[font];if(!',657,']){',657,']=[];this.',19,543,663,')]);}else{',472,'TeXAtom(',310,'atom[type],code,font));}},','HandleVariable',44,'(c',1095,'7,1',',c.charCodeAt(0));},','HandleNumber',44,'(c',1095,'7,0',1125,'HandleOther',44,'(c){',472,1073,'",c,"normal"));},HandleComment',44,116,'c;',132,172,'c=',65,1046,'c=="\\r"||c=="\\n"){return;}}},HandleStyle',129,',_365){',82,'data.style=_365[0];',82,506,'style",{style:_365[0]}));},',1,129,',size){',82,89,'=size[0];',82,506,'size",{size:size[0]}));},HandleFont',129,',font){',82,87,'=font[0];},HandleCS',44,116,'cmd',54,114,'();',201,';}if(this.macros[cmd]){var _36b',54,'macros[cmd];',69,'_36b',875,'_36b=[_36b];}this[_36b[0]](cmd,_36b.slice(1));',540,'if(','this.mathchardef[cmd',']){this.HandleMathCode(','cmd,',1184,']);',540,'if(',261,160,'cmd',1185,'cmd,',261,160,'cmd].slice(0,3));',540,141,'Unknown control sequence \'"+',160,'cmd+"\'");},HandleOpen',44,'(){',82,'Open();},HandleClose',44,'(){if(',82,715,'==null){',141,151,194,478,'open=',82,'Get(',82,715,');if(!open||','open.left',1212,82,'Close();}else{',141,151,' or missing',726,194,';}},HandleLeft',129,80,'left',54,242,502,';}',82,'Open(left);},HandleRight',129,80,'_370',54,242,502,478,'open=',82,'Get(',82,715,722,'&&',1223,550,82,'Close(_370);}else{',141,'Extra open brace or missing "+this.cmd+"left");}},HandleOver',129,547,'if(',82,732,550,141,'Ambiguous use of "+',160,200,540,82,732,'=',82,'Length();',82,'data.overF={name:name};if(data.length>0){',82,'data.overF.','left=',261,'data[0]];',82,1281,'right=',261,'data[1]];}else{if(name.match(/withdelims$/)){',82,1281,'left',54,242,502,';}',82,1281,'right',54,242,502,';}}else{',82,1281,'left=null;',82,1281,1287,'null;}}if(name.match(/^above/)){',82,1281,'thickness',495,496,201,1303,82,1281,'thickness=null;}},HandleSuperscript',44,116,462,82,104,'(base==null||(!base',106,467,'box"&&',467,'frac")){',462,472,473,474,'if(',490,'){',462,472,473,'else{',141,'Double exponent',477,';}}base.sup',54,204,'("superscript");',201,';}},HandleSubscript',44,116,462,82,104,'(base==null||(!base',106,467,'box"&&',467,'frac")){',462,472,473,'if(base.sub){',141,'Double subscripts',477,';}base.sub',54,204,'("subscript");',201,';}},Parse',44,116,'c;',132,172,'c=',65,1046,'this.mathchar[c',1185,'c,',1384,']);}else{if(this',48,'c]){this[this',48,'c]](c',');}else{if(','this.letter','.test(c)){this.',1120,'(c',1393,'this.number',1395,1126,'(c);}else{this.',1132,'(c);}}}}}if(',82,715,550,'var open=',82,'Get(',82,715,722,'.left){',141,142,726,727,141,193,'");}}if(',82,732,550,82,'Over();}},Atomize',44,116,'data=',82,'init;if(!this',56,82,739,701,');}},Typeset',44,116,'data=',82,'init;var box',54,'typeset=',82,666,701,');',201,' "<span class=\\"error\\">"+',57,'+"</span>";}if(box.format=="null"){return "";}box.Styled().Remeasured();var _37b=0;var _37c','=0;if(box.bh>','box.h&&box.bh>',85,'h','+0.001){_37b=1;}if(box.','bd>box.d&&box.bd>',85,'d',1456,'h>',85,'h||box.d>',85,'d){_37c=1',478,'html=box.html;if(_37b){if(','jsMath.Browser.','allowAbsolute',80,'y',1452,85,'h+0.001){y=',85,'h-box.bh;}html=',933,'Absolute(html,box.w,',85,'h,0,y,',85,'h',1393,1468,'valignBug){','html="<span style=\\"line-height:"+jsMath.HTML.Em(jsMath.d',')+";\\">"+',941,'>";}else{var dy=',933,'Em(Math.max(0,box.bd-',85,'hd)/3);',1486,')+";"+" position:relative; top:"+dy+"; ',938,'dy+"\\">"+',941,'>";}}_37c=1;}if(_37c){html+=',933,'Blank(0,box.h+0.05,box.d+0.05);}return "<nobr><span class=\\"scale\\">"+',941,'></nobr>";}});',47,'.AddSpecial({cmd:"HandleCS",open:"HandleOpen",close:"HandleClose"});','jsMath.Add(jsMath,{',5,129,80,'_381=',47,'.macros;','_381','[name]=["',5,'"];for(var i=1;i<arguments.length;i++){_381[name][_381[name].length]=arguments[i];}}});',85,19,'={safeRequire:1,',5,129,',file',80,'_385=',47,1512,'if(file',1212,'file=name;}_385',1514,19,'",file];},LaTeX',44,'(env,file',80,'_388=',47,'.',37,';_388[env]=["',19,'",file,"',37,'"];},Font',129,1164,'if(font',1212,'font=name+"10";}var _38b=',47,1512,'_38b',1514,19,'",',663,')];},MathChar',44,'(font,defs',80,'fam=',310,'famName[font','];if(fam',1212,1561,310,'fam.length;',310,'fam[fam]=font;',310,1563,']=fam',478,'_38f=',47,'.mathchardef;for(var c in defs){_38f[c]=[defs[c][0],fam,defs[c][1]];}},',35,44,'(file,show){if(this.safeRequire&&(file.match(/\\.\\.\\/|[^-a-z0-9.\\/:_+=%~]/i)||(file.match(/:/)&&file.substr(0,',85,'root.length)!=',85,'root))){',537,538,']=1;',540,537,'Script(this.URL(file),show);},URL',44,'(file){file=file',75,'+$/g,"");if(!file.match(/^([a-z]+:|\\/|fonts|extensions\\/)/i)){file="extensions/"+file;}if(!file.match(/\\.js$/)){file+=".js";}',64,'file;}};',1506,77,44,45,537,'Body();','jsMath.Script.','Push(',548,',"','Asynchronous','",obj);},ProcessBeforeShowing',44,45,537,1602,'var _396=(','jsMath.Controls.cookie.','asynch?"',1607,'":"','Synchronous','");',1603,1604,548,',_396,obj);}});',548,'={element:[],cancel:0,Parse',44,'(_397,s,_399',80,'_39a=',85,'Global.','cache[_397];if(!','_39a[jsMath.em',']){',1633,']={};}var HTML=',1633,'][s];if(!HTML||_399',80,'_39c=',85,'Parse(s,null,null,_397);_39c.Atomize();HTML=_39c.Typeset();if(!_399){',1633,'][s]=HTML;}}',64,'HTML;},TextMode',44,'(s,_39e){this.Parse("T",s,_39e);},DisplayMode',44,'(s,_3a0){this.Parse("D",s,_3a0);},','GetElementText',44,'(_3a1',901,'recursiveElementText','(_3a1);_3a1.alt=text;if(text.search("&")>=0){','text=text.replace(/&','lt;/g,"<");',1657,'gt;/g,">");',1657,'quot;/g,"\\"");',1657,'amp;/g,"&");}',64,'text;},',1655,44,'(_3a3){if(','_3a3.nodeValue','!=null',166,1670,';}if(','_3a3.childNodes.length','==0){return " ";}var text="";',1013,1675,';i++){text+=this.',1655,'(_3a3.childNodes[i]);}',64,1666,'ResetHidden',44,'(_3a6){_3a6.innerHTML',937,'visibility: hidden; position:absolute; top:0px;left:0px;\\"></span>"+',1468,'operaHiddenFix;_3a6.className="";',85,'hidden=_3a6.firstChild;if(!',85,'BBoxFor("x").w){','jsMath.hidden=jsMath.hiddenTop',';}',85,'ReInit();},','ConvertText',44,'(_3a7,_3a8',901,1651,'(_3a7',');this.ResetHidden(','_3a7',');if(text.match(/^\\s*\\\\nocache([^a-zA-Z])/)){','_3a8','=true;text=text.replace(/\\s*\\\\nocache/,"");}text=this.Parse("','T",text,_3a8);_3a7','.className="typeset";','_3a7','.innerHTML=text;},','ConvertDisplay',44,'(_3aa,_3ab',901,1651,'(_3aa',1705,'_3aa',1707,'_3ab',1709,'D",text,_3ab);_3aa',1711,'_3aa',1713,'ProcessElement',44,'(_3ad){','this.restart','=0;var _3ae=(','_3ad.className','.toLowerCase().match(/(^| )nocache( |$)/)!=null);try','{if(_3ad.tagName.toLowerCase()=="','div"){this.',1714,'(_3ad,_3ae);_3ad.onclick=jsMath.Click.CheckClick;_3ad.ondblclick=jsMath.Click.CheckDblClick',';}else',1736,'span"){this.',1699,1739,';}}}catch(err){if(_3ad.alt',80,'tex=_3ad.alt;','tex=tex.replace','(/&/g,"&amp;");',1748,'(/</g,"&lt;");',1748,'(/>/g,"&gt;");_3ad.innerHTML=tex;',1734,'="math";if(_3ae){',1734,'+=" nocache";}}',1695,';}},','ProcessElements',44,'(k){',1603,'blocking=','1;if(k>=','this.element.length','||','this.cancel','){this.','ProcessComplete','();if(',1768,'){','jsMath.Message.','Set("',77,' Math: Canceled");',1774,'Clear();}',1603,1764,'0;',1603,77,'();}else{','this.ProcessElement(this.element[','k]);if(',1732,'){',1603,1604,'this,"',1760,'",k);',1603,1764,'0;setTimeout("',1603,77,'()",',1468,'delay);}else{k++;var p=Math.floor(100*k/',1766,');','jsMath.Message.Set("Processing Math',': "+p+"%");setTimeout("',548,'.',1760,'("+k+")",',1468,'delay);}}},',1607,44,'(obj','){if(!jsMath.initialized){jsMath.Init();}this.element=this.GetMathElements(obj);',1768,'=0;this',560,'=1;',1603,1764,'1;',1805,': 0%",1);setTimeout("',548,'.',1760,'(0)",',1468,'delay);},',1618,44,'(obj,i){if(i==null',1816,'i=0;}this',560,1035,1766,'){',1786,'i]);if(',1732,'){',85,'Synchronize','("',548,'.',1618,'(null,"+i+")");',1603,77,'();',540,'i++;}this.',1770,'(1);},GetMathElements',44,45,'var _3b6=[];if(!obj){obj=','jsMath.document',';}',69,'obj',875,'obj=',1862,'.getElementById(obj);}if(!','obj.getElementsByTagName','){',95,'var math=',1870,'("div','");for(var k=0;k<math.length;k++){if(math[k].className&&math[k].className.match(/(^| )math( |$)/)){if(jsMath.Browser.renameOK&&obj.getElementsByName){math[k].setAttribute("name","_jsMath_");}else{_3b6[_3b6.length]=math[k];}}}','math=',1870,'("span',1876,'if(',1468,'renameOK','&&obj','.getElementsByName','){_3b6=obj',1885,'("_jsMath_',727,'if(',85,'hidden','.sourceIndex','){_3b6.sort(function(a,b',166,'a',1893,'-b',1893,';});}}',64,'_3b6;},',1770,44,'(_3bc){if(',1468,1883,80,'_3bd=',1862,1885,1888,'");for(var i=_3bd.length-1;i>=0;i--){_3bd[i].removeAttribute("name");}}',1695,';this.element=[];if(!_3bc){',1805,': Done");',1774,'Clear();}',1774,'UnBlank();if(',1468,'safariImgBug&&(',1614,'font=="symbol"||',1614,'font=="image")){if(','this.timeout','){clearTimeout(',1928,');}',1928,'=setTimeout("','jsMath.window.resizeBy','(-1,0); "+"',1934,'(1,0); "+"',548,'.timeout = null",2000);}},Cancel',44,'(){',548,'.cancel=1;if(',1603,'cancelTimer){',1603,'cancelLoad();}}};',1506,'ConvertTeX',44,'(_3bf){',1603,'Push(jsMath.tex2math,"',1949,'",_3bf);},','ConvertTeX2',44,'(_3c0){',1603,1953,1956,'",_3c0);},','ConvertLaTeX',44,'(_3c1){',1603,1953,1963,'",_3c1);},','ConvertCustom',44,'(_3c2){',1603,1953,1970,'",_3c2);},','CustomSearch',44,'(om,cm,od,cd','){',1603,1604,'null,function(){',85,'tex2math.',1977,1979,');});},tex2math:{',1949,44,457,1956,44,457,1963,44,457,1970,44,457,1977,44,'(){}}});',85,1846,'=',1603,1846,';try{if(','window.parent','!=window&&window.jsMathAutoload){',2010,'.jsMath=jsMath;',1862,'=',2010,'.document;',85,'window=',2010,';}}catch(err){}',85,1631,'Register();',85,'Loaded();',85,'Controls.GetCookie();',537,'Source();',85,1631,'Init();',1603,'Init();',537,'Fonts();if(',1862,'.body){jsMath.Setup.Body();}}}']
]);
//end = new Date().getTime();
//alert(end-start);
